c
c      The program of AVERAGing phases from .OUT-file   17.12.2010
c
       parameter (maxref=4000,maxvar=200,mxbin=40,mxzon=100,
     *            mxshft=8,maxsym=48,mxcor=200 000,mxcszn=20)
c
       integer ih(maxref),ik(maxref),il(maxref),mult(maxref)
       dimension fobs(maxref),ww(maxref)
       dimension wf(maxref),wphi(maxref),ss(maxref)
       dimension tstflg(maxref),iflag(maxref)
       dimension ph(maxref,maxvar),phex(maxref)
       dimension f(maxref,maxvar)
       dimension sumcor(maxvar),rasst(maxvar)
       dimension fom(maxref),phave(maxref)
       dimension tcalc(maxref),phcalc(maxref)
       integer as1(mxcszn),as2(mxcszn),as3(mxcszn)
       dimension b1(mxcszn),b2(mxcszn),b3(mxcszn)
       dimension ncsz(maxref)
       dimension shift(3,mxshft),naxes(3)
       dimension cor(mxcor)
       dimension symmat(12,maxsym)
       dimension ihi(mxbin)
       dimension sfom(mxzon),krefz(mxzon),ssmi(mxzon),ssma(mxzon)
       dimension ddmi(mxzon),ddma(mxzon)
c
       logical isenan,logovr,isovr,logen,isex,usfobs
       logical phadef,pharad,phadfp,phardp
c
       nudat=7
       nuin=11
       nuspr=13
       nuprot=14
       numes=nuprot
       nuout=15
c
       dd=1.e+10
       pi=3.1415927
       twopi=2.*pi
       ir=14159263
       delta=2./mxbin
       k=0
       s1=0.
       s2=0.
       cs1=0.
       cs2=0.
       w=0.
c
       call rddat(nudat,nuprot,nuin,nuout,
     *      ngr,acell,bcell,ccell,alfa,beta,gamma,
     *      isex,usfobs,dshmin,dshmax,dstep,isovr,
     *      phadef,pharad,nzon,mxzon,ddmi,ddma)
       ssmish=1./(dshmax*dshmax)
       ssmash=1./(dshmin*dshmin)
       call coeff(acell,bcell,ccell,alfa,beta,gamma,
     *                 ar11,ar12,ar13,ar22,ar23,ar33,
     *                 a11,a12,a13,a22,a23,a33,vol)
       call rdspr(nuspr,nuprot,ngr,maxsym,nsym,symmat,
     *                 ncszon,mxcszn,as1,as2,as3,b1,b2,b3,
     *                 mxshft,nshift,shift,isenan,kaxes,naxes)
       nax=naxes(1)
       if (kaxes.ne.0) call dfnpoi(acell,bcell,ccell,dstep,
     *               kaxes,naxes,nnpoin,nnx,nny,nnz)
c
       write (nuprot,'(/1x,a63/)')
     *'********** Input file statistics ******************************'
       read (nuin,*,end=100) nref
       if (nref.gt.maxref) then
          write (nuprot,'(1x,a33,i8)')
     *      'Too large number of reflections: ',nref
          write (nuprot,'(1x,a29,i8)')
     *      'Maximal admissible number is ',maxref
          stop 'Too large number of reflections'
       end if
c
       do i=1,nref
          read (nuin,*,end=100) ih(i),ik(i),il(i),fobs(i),tstflg(i)
          s21=ar11*ih(i)*ih(i)+ar22*ik(i)*ik(i)+ar33*il(i)*il(i)
          s22=2*ar12*ih(i)*ik(i)+2*ar13*ih(i)*il(i)+2*ar23*ik(i)*il(i)
          ss(i)=s21+s22
          if (fobs(i).ne.dd) then
              iflag(i)=1
             else
              iflag(i)=0
          end if
          nn=0
          DO j=1,ncszon
             iw=as1(j)*ih(i)+as2(j)*ik(i)+as3(j)*il(i)
             IF (nn.eq.0.and.iw.eq.0) nn=j
          END DO
          ncsz(i)=nn
       end do
       call multi(maxsym,nsym,symmat,maxref,nref,ih,ik,il,mult)
cccccccccccccccccccccccccccccccccccccccccccccccccccc
       if(isex) then
          read(nuin,'((6g12.5))',end=8)
     *          q,(phex(i),i=1,nref),(ww(i),i=1,nref)
          call intpha(nref,phex,phardp,phadfp)
          call chkint(nuprot,phadef,phadfp,pharad,phardp)
          if (.not.pharad) then
             do i=1,nref
                if (phex(i).ne.dd) phex(i)=phex(i)*pi/180.
             end do
          end if
          do i=1,mxbin
             ihi(i)=0
          end do
       end if
       k=1
       s1=0.
       s2=0.
       qmin=1.
       qmax=-1.
       cs1=0.
       cs2=0.
       ccmin=1.
       ccmax=-1.
cccccccccccccccccccccccccccccccccccccccccccccccccccc
7      continue
       read(nuin,'((6g12.5))',end=8)q,(ph(i,k),i=1,nref),
     *             (f(i,k),i=1,nref)
       if (.not.phadef.and..not.phadfp) then
          call intpha(nref,ph,phardp,phadfp)
          call chkint(nuprot,phadef,phadfp,pharad,phardp)
       end if
       if (k.eq.1) then
         qmin=q
         qmax=q
       end if
       s1=s1+q
       s2=s2+q*q
       if (q.lt.qmin) qmin=q
       if (q.gt.qmax) qmax=q
cccccccccccccccccccccccccccccccc
       if (isex) then
ccc
       if (usfobs) then
           CALL optsh3(nref,ih,ik,il,ss,iflag,ssmish,ssmash,mult,
     *      fobs,phex,fobs,ph(1,k),
     *      nshift,shift,kaxes,nax,nnpoin,nnx,nny,nnz,
     *      isenan,isovr,numes,wf,wphi,cor,mxcor,
     *      logen,logovr,xopt,yopt,zopt,cmax)
         else
           CALL optsh3(nref,ih,ik,il,ss,iflag,ssmish,ssmash,mult,
     *      fobs,phex,f(1,k),ph(1,k),
     *      nshift,shift,kaxes,nax,nnpoin,nnx,nny,nnz,
     *      isenan,isovr,numes,wf,wphi,cor,mxcor,
     *      logen,logovr,xopt,yopt,zopt,cmax)
       endif
ccc
           if (cmax.lt.ccmin) ccmin=cmax
           if (cmax.gt.ccmax) ccmax=cmax
           cs1=cs1+cmax
           cs2=cs2+cmax*cmax
           nbin=cmax/delta+1+mxbin/2
           if(nbin.lt.0) nbin=1
           if(nbin.gt.mxbin) nbin=mxbin
           ihi(nbin)=ihi(nbin)+1
       end if
cccccccccccccccccccccccccccccccc
       k=k+1
       if(k.le.maxvar) goto 7
8      continue
       kvar=k-1
       write (nuprot,'(3x,i5,a44)') kvar,
     *  ' phase variants were found in the input file'
       nax=naxes(1)
       if(.not.pharad) then
           do i=1,nref
           do j=1,kvar
              if (ph(i,j).ne.dd) ph(i,j)=ph(i,j)*pi/180.
           end do
           end do
       end if
       if (kvar.ne.0) ave=s1/kvar
       if(kvar.ne.0) w=s2/kvar
       rms=sqrt(abs(w-ave*ave))
       write(nuprot,'(1x,a51/3x,4g13.4)')
     *  'The search criterion values (qmin, qmax, ave, rms):',
     *   qmin,qmax,ave,rms
       if (kvar.ne.0) ave=cs1/kvar
       if(kvar.ne.0) w=cs2/kvar
       rms=sqrt(abs(w-ave*ave))
       write(nuprot,'(/1x,a53/3x,a19,4f8.4/)')
     *  'Map correlation with respect to the reference phases:',
     *  'cmin,cmax,ave,rms: ',ccmin,ccmax,ave,rms
       write(nuprot,'((10i5))') (ihi(i),i=1,mxbin)
c
       disma=-dd
       do i=1,kvar
         sumcor(i)=0.
         do j=1,kvar
           if(usfobs) then
               CALL optsh3(nref,ih,ik,il,ss,iflag,ssmish,ssmash,mult,
     *          fobs,ph(1,i),fobs,ph(1,j),
     *          nshift,shift,kaxes,nax,nnpoin,nnx,nny,nnz,
     *          isenan,isovr,numes,wf,wphi,cor,mxcor,
     *          logen,logovr,xopt,yopt,zopt,cmax)
             else
               CALL optsh3(nref,ih,ik,il,ss,iflag,ssmish,ssmash,mult,
     *          f(1,i),ph(1,i),f(1,j),ph(1,j),
     *          nshift,shift,kaxes,nax,nnpoin,nnx,nny,nnz,
     *          isenan,isovr,numes,wf,wphi,cor,mxcor,
     *          logen,logovr,xopt,yopt,zopt,cmax)
           end if
           sumcor(i)=sumcor(i)+cmax
         end do
         if(sumcor(i).gt.disma) then
           disma=sumcor(i)
           numiva=i
         end if
       end do
ccccccccccccccccccccccccccccccccccccc
       rasmi=2.
       rasma=0.
       do i=1,mxbin
          ihi(i)=0
       end do
       s1=0.
       s2=0.
       do i=1,kvar
          rasst(i)=sqrt(2.-2.*sumcor(i)/kvar)
          if(rasst(i).lt.rasmi) then
             rasmi=rasst(i)
             numira=i
          end if
          if(rasst(i).gt.rasma) rasma=rasst(i)
          s1=s1+rasst(i)
          s2=s2+rasst(i)*rasst(i)
          nbin=rasst(i)/delta+1
          if(nbin.lt.0) nbin=1
          if(nbin.gt.mxbin) nbin=mxbin
          ihi(nbin)=ihi(nbin)+1
       end do
       if (kvar.ne.0) ave=s1/kvar
       if(kvar.ne.0) w=s2/kvar
       rms=sqrt(abs(w-ave*ave))
       write(nuprot,'(/1x,a25/1x,a19,4f8.2)')
     *       'Mean radius of the cloud:',
     *       'rmin,rmax,ave,rms: ',rasmi,rasma,ave,rms
       write(nuprot,'((10i5))') (ihi(i),i=1,mxbin)
       write (nuprot,'(/1x,a63/)')
     *'********** Averaging ******************************************'
       write(nuprot,'(1x,a36,i4,a20)')
     *       'The program has defined the variant ',numiva,
     *       ' as the middle point'
c----------------------------------------
c      numiva - number of rep. variant
c      now we shift all variants to the middle one
c----------------------------------------
       ccmin=1.
       ccmax=-1.
       s1=0.
       s2=0.
       do i=1,mxbin
          ihi(i)=0
       end do
       i=numiva
         do j=1,kvar
           if(usfobs) then
               CALL optsh3(nref,ih,ik,il,ss,iflag,ssmish,ssmash,mult,
     *          fobs,ph(1,i),fobs,ph(1,j),
     *          nshift,shift,kaxes,nax,nnpoin,nnx,nny,nnz,
     *          isenan,isovr,numes,wf,wphi,cor,mxcor,
     *          logen,logovr,xopt,yopt,zopt,cmax)
             else
               CALL optsh3(nref,ih,ik,il,ss,iflag,ssmish,ssmash,mult,
     *          f(1,i),ph(1,i),f(1,j),ph(1,j),
     *          nshift,shift,kaxes,nax,nnpoin,nnx,nny,nnz,
     *          isenan,isovr,numes,wf,wphi,cor,mxcor,
     *          logen,logovr,xopt,yopt,zopt,cmax)
           end if
           if (cmax.lt.ccmin) ccmin=cmax
           if (cmax.gt.ccmax) ccmax=cmax
           s1=s1+cmax
           s2=s2+cmax*cmax
           nbin=cmax/delta+1+mxbin/2
           if(nbin.lt.0) nbin=1
           if(nbin.gt.mxbin) nbin=mxbin
           ihi(nbin)=ihi(nbin)+1
           if (logen) then
                sen=-1
               else
                sen=1
           end if
           if (logovr) then
              povr=pi
             else
              povr=0
           end if
           do k=1,nref
              pp=sen*ph(k,j)-
     *                2*PI*(xopt*ih(k)+yopt*ik(k)+zopt*il(k))+povr
              call zphnor(pp,1)
              ph(k,j)=pp
           end do
         end do
         if (kvar.ne.0) ave=s1/kvar
         if(kvar.ne.0) w=s2/kvar
         rms=sqrt(abs(w-ave*ave))
       write(nuprot,'(/1x,a34,a34/3x,a19,4f8.4/)')
     *  'Map correlation of phase variants ',
     *  'with respect to the middle phases:',
     *  'cmin,cmax,ave,rms: ',ccmin,ccmax,ave,rms
       write(nuprot,'((10i5))') (ihi(i),i=1,mxbin)
c----------------------------------------
c      now we have shifted all variants to the rep. one
c----------------------------------------
          do i=1,nref
          s1=0.
          s2=0.
          s3=0.
          s4=0.
          do j=1,kvar
             s1=s1+cos(ph(i,j))
             s2=s2+sin(ph(i,j))
             s3=s3+f(i,j)*cos(ph(i,j))
             s4=s4+f(i,j)*sin(ph(i,j))
          end do
          if(kvar.ne.0) then
             s1=s1/kvar
             s2=s2/kvar
             s3=s3/kvar
             s4=s4/kvar
          end if
          fom(i)=sqrt(abs(s1*s1+s2*s2))
          if(fom(i).ne.0.) then
                phave(i)=atan2(s2,s1)
               else
                r=urand(ir)
                if(ncsz(i).ne.0) then
                   n=ncsz(i)
                   w=b1(n)*ih(i)+b2(n)*ik(i)+b3(n)*il(i)
                   w=w*pi
                   if(r.le.0.5) then
                      phave(i)=w
                     else
                      phave(i)=w+pi
                   end if
                  else
                   phave(i)=r*twopi
                end if
          end if
          tcalc(i)=sqrt(abs(s3*s3+s4*s4))
          if(tcalc(i).ne.0.) then
                phcalc(i)=atan2(s4,s3)
               else
                r=urand(ir)
                if(ncsz(i).ne.0) then
                   n=ncsz(i)
                   w=b1(n)*ih(i)+b2(n)*ik(i)+b3(n)*il(i)
                   w=w*pi
                   if(r.le.0.5) then
                      phcalc(i)=w
                     else
                      phcalc(i)=w+pi
                   end if
                  else
                   phcalc(i)=r*twopi
                end if
          end if
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c           problema 10 v desyatoi
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          end do
          call phsym(nref,ih,ik,il,ncszon,as1,as2,as3,
     *           b1,b2,b3,phave)
ccccccccccccccccccccccccccccccccccccccccc
c         shift to the exact phases
ccccccccccccccccccccccccccccccccccccccccc
         if (isex) then
           CALL optsh3(nref,ih,ik,il,ss,iflag,ssmish,ssmash,mult,
     *          fobs,phex,fobs,phave,
     *          nshift,shift,kaxes,nax,nnpoin,nnx,nny,nnz,
     *          isenan,isovr,numes,wf,wphi,cor,mxcor,
     *          logen,logovr,xopt,yopt,zopt,cmax)
           if (logen) then
                sen=-1
               else
                sen=1
           end if
           if (logovr) then
              povr=pi
             else
              povr=0
           end if
           do k=1,nref
              pp=sen*phave(k)-
     *                2*PI*(xopt*ih(k)+yopt*ik(k)+zopt*il(k))+povr
              call zphnor(pp,1)
              phave(k)=pp
           end do
           write (nuprot,'(/1x,a62)')
     * 'Map correlation with respect to the reference phases for maps:'
           write (nuprot,'(1x,a23,f8.4)')
     *     '(F_obs,P_ave)-map:     ',cmax
           do i=1,nref
              ww(i)=fobs(i)*fom(i)
           end do
           CALL optsh3(nref,ih,ik,il,ss,iflag,ssmish,ssmash,mult,
     *          fobs,phex,ww,phave,
     *          nshift,shift,kaxes,nax,nnpoin,nnx,nny,nnz,
     *          isenan,isovr,numes,wf,wphi,cor,mxcor,
     *          logen,logovr,xopt,yopt,zopt,cmax)
           write (nuprot,'(1x,a23,f8.4)')
     *     '(F_obs*FOM,P_ave)-map: ',cmax
cccccccccccccccccccccccccccccccccccccccc
c           for fobs, phcalc
cccccccccccccccccccccccccccccccccccccccc
           CALL optsh3(nref,ih,ik,il,ss,iflag,ssmish,ssmash,mult,
     *          fobs,phex,fobs,phcalc,
     *          nshift,shift,kaxes,nax,nnpoin,nnx,nny,nnz,
     *          isenan,isovr,numes,wf,wphi,cor,mxcor,
     *          logen,logovr,xopt,yopt,zopt,cmax)
           write (nuprot,'(1x,a23,f8.4)')
     *     '(F_obs,P_calc)-map:    ',cmax
cccccccccccccccccccccccccccccccccccccccc
c           for tcalc, phcalc
cccccccccccccccccccccccccccccccccccccccc
           CALL optsh3(nref,ih,ik,il,ss,iflag,ssmish,ssmash,mult,
     *          fobs,phex,tcalc,phcalc,
     *          nshift,shift,kaxes,nax,nnpoin,nnx,nny,nnz,
     *          isenan,isovr,numes,wf,wphi,cor,mxcor,
     *          logen,logovr,xopt,yopt,zopt,cmax)
           if (logen) then
                sen=-1
               else
                sen=1
           end if
           if (logovr) then
              povr=pi
             else
              povr=0
           end if
           do k=1,nref
              pp=sen*phcalc(k)-
     *                2*PI*(xopt*ih(k)+yopt*ik(k)+zopt*il(k))+povr
              call zphnor(pp,1)
              phcalc(k)=pp
           end do
           write (nuprot,'(1x,a23,f8.4)')
     *     '(T_calc,P_calc)-map:   ',cmax
         end if
ccccccccccccccccccccccccccccccccccccccccccccccccccccc
c          FOM-statistics
ccccccccccccccccccccccccccccccccccccccccccccccccccccc
           do i=1,nzon
              ssmi(i)=1./(ddma(i)*ddma(i))
              ssma(i)=1./(ddmi(i)*ddmi(i))
              sfom(i)=0.
              krefz(i)=0
           end do
           do i=1,nref
              do n=1,nzon
                 if (ssmi(n).le.ss(i).and.ss(i).le.ssma(n)) then
                     sfom(n)=sfom(n)+fom(i)
                     krefz(n)=krefz(n)+1
                 end if
              end do
           end do
           do i=1,nzon
              if(krefz(i).ne.0) sfom(i)=sfom(i)/krefz(i)
           end do
           write (nuprot,'(/1x,a15)') 'FOM-statistics:'
           write (nuprot,'(/1x,a20,a6,a8)')
     *           '  resolution','  ref','  <FOM>'
           do i=1,nzon
              write(nuprot,'(2x,f9.4,a1,f9.4,i6,f8.4)')
     *              ddmi(i),'-',ddma(i),krefz(i),sfom(i)
           end do
cccccccccccccccccccccccccccccccccccccc
c              OUTPUT
cccccccccccccccccccccccccccccccccccccc
          call outfil(nuout,nref,ih,ik,il,fobs,tstflg,fom,phave,
     *     tcalc,phcalc,isex,phex,pharad)
          stop
100       continue
          write (nuprot,'(1x,a23)') 'Error in input file !!!'
          stop 'Error in input file !!!'
          end
       SUBROUTINE rddat(nudat,nuprot,nuin,nuout,
     *      ngr,acell,bcell,ccell,alfa,beta,gamma,
     *      isex,usfobs,dshmin,dshmax,dstep,isovr,
     *      phadef,pharad,nzon,mxzon,ddmi,ddma)
c
       character fin*72,inp*72,titl1*72,titl2*72,txt*60
       character cdstep*4,fprot*12,modovr*1,fout*12
       character ansex*1
       dimension ddmi(mxzon),ddma(mxzon)
       logical isovr,isex,usfobs,phadef,pharad
c
       nuw=20
       open (nudat,file='average.dat')
       open (nuw,file='qq')
c
1      continue
       read (nudat,'(a72)',end=10) inp
       if (inp(1:1).eq.'!') goto 1
       write (nuw,'(a72)') inp
       goto 1
10     continue
       close(nudat)
       rewind(nuw)
       nudat=nuw
c
       cdstep='    '
       fout='            '
       read (nudat,'(a4)',end=100) cdstep
       do j=1,4
          i=5-j
          if (cdstep(i:i).ne.' ') goto 11
       end do
       stop 'Invalid cod of step'
11     continue
       lcdstp=i
       fprot(1:lcdstp)=cdstep
       fprot(lcdstp+1:lcdstp+8)='_ave.mes'
       open(nuprot,file=fprot)
       fout(1:lcdstp)=cdstep
       fout(lcdstp+1:lcdstp+8)='_ave.uf'
       open(nuout,file=fout)
       write (nuprot,'(1x,20x,a7,18x,a25)')
     *        'AVERAGE','Version 1.1   17.12.2010'
       read (nudat,'(a72)',end=100) fin
       write (nuprot,'(1x,a17,a50)') 'Input file name: ',fin
       open (nuin,file=fin,err=100,iostat=io,status='old')
       if (io.ne.0) goto 100
c
       write (nuprot,'(1x,a22)') 'Input file titles are:'
       read (nuin,'(a72)',end=100) titl1
       write (nuprot,'(1x,a72)') titl1
       read (nuin,'(a72)',end=100) titl2
       write (nuprot,'(1x,a72)') titl2
c
       read (nudat,*,end=100) ngr
       write (nuprot,'(1x,a20,i3)') 'Space group number: ',ngr
       read (nudat,*,end=100) acell,bcell,ccell,alfa,beta,gamma
       write (nuprot,'(1x,a10,3f8.2,3x,3f4.0)') 'Unit cell:',
     *           acell,bcell,ccell,alfa,beta,gamma
       write (txt,'(3f8.2,3x,3f4.0)')
     *           acell,bcell,ccell,alfa,beta,gamma
       titl1(1:23)='Output data of AVERAGE '
       titl1(24:62)=txt(1:39)
       write (txt,'(i3)') ngr
       titl1(63:64)=' N'
       titl1(65:67)=txt(1:3)
       write (nuout,'(a72)') titl1
ccccccccccccccccccccccccccccccccccccccccccccccc
          read (nudat,'(a72)',end=100) inp
       read (inp,'(a1)',end=100) ansex
       if(ansex.eq.'n') ansex='N'
       if(ansex.eq.'y') ansex='Y'
       write(nuprot,'(1x,a31,a32,a1)')
     *       'Whether reference phase values ',
     *       'are present in the input files: ',ansex
       if (ansex.ne.'Y'.and.ansex.ne.'N') then
           write(nuprot,'(1x,a50)')
     *     'Invalid answer about reference phases. Must be Y/N'
           stop 'Invalid answer about reference phases. Must be Y/N'
       end if
       isex=ansex.eq.'Y'
       titl2='h k l Fobs Test_flag FOM Ph_ave T_calc Ph_calc'
       if (isex) titl2(48:52)='Ph_ex'
       write (nuout,'(a72)') titl2
ccccccccccccccccccccccccccccccccccccccccccccccc
       call digrad(nuprot,inp,phadef,pharad)
       if (phadef) then
          if (pharad)     txt='Input phases are defined in radians'
          if (.not.pharad)txt='Input phases are defined in degrees'
         else
          txt=
     *    'RADIAN/DEGREE information is not defined in the control data'
       end if
       write (nuprot,'(1x,a60)') txt
ccccccccccccccccccccccccccccccccccccccccccccccc
       write (nuprot,'(1x,a20)') 'Maps alignment mode:'
       read (nudat,'(a1)',end=100) ansex
       if(ansex.eq.'n') ansex='N'
       if(ansex.eq.'y') ansex='Y'
       write(nuprot,'(3x,a40,a1)')
     *       'whether Fobs will be used for all maps: ',ansex
       if (ansex.ne.'Y'.and.ansex.ne.'N') then
           write(nuprot,'(1x,a44)')
     *     'Invalid answer about Fobs using. Must be Y/N'
           stop 'Invalid answer about Fobs using. Must be Y/N'
       end if
       usfobs=ansex.eq.'Y'
c
       read (nudat,'(a72)',end=100) inp
       read (inp,*,end=100) dshmin,dshmax
       call readad(inp,dstep)
       if (dstep.eq.0) dstep=dshmin/4
       read (nudat,'(a1)') modovr
       call invers(dshmin,dshmax)
       write (nuprot,'(3x,a19,f7.2,a3,f7.2)')
     *   'resolution limits: ',dshmin,' - ',dshmax
       write (nuprot,'(3x,a48,f7.2)')
     *   'minimal trial step (in A) for the origin shift: ',dstep
       write (nuprot,'(3x,a52,a1)')
     *   'whether the map flip is a permitted transformation: ',modovr
       if(modovr.eq.'y') modovr='Y'
       if(modovr.eq.'n') modovr='N'
       if(modovr.ne.'Y'.and.modovr.ne.'N') then
          write(nuprot,'(a24)') ' Invalid flipped mode!!!'
          stop ' Invalid flipped mode!!!'
       end if
       isovr=modovr.eq.'Y'
ccccccccccccccccccccccccccccccccccccccccccccc
       read (nudat,*,end=100) nzon
       write (nuprot,'(1x,a47,i2)')
     *   'Number of resolution zones for FOM-statistics: ',nzon
       if(nzon.gt.mxzon) then
         write (nuprot,'(1x,a20)') 'NZON is too large!!!'
         stop 'NZON is too large!!!'
       end if
       write (nuprot,'(3x,a36)')'the corresponding resolution limits:'
       do i=1,nzon
          read (nudat,*,end=100) ddmi(i),ddma(i)
          call invers(ddmi(i),ddma(i))
          write(nuprot,'(3x,f9.4,a1,f9.4)') ddmi(i),'-',ddma(i)
       end do
       close(nudat,status='delete')
       return
100    continue
       write (nuprot,'(1x,a19)') 'Invalid format data'
       close(nudat,status='delete')
       stop
       end
      SUBROUTINE invers(a,b)
         if (a.gt.b) then
              w=a
              a=b
              b=w
         end if
      RETURN
      END
      SUBROUTINE readad(inp,dstep)
      character inp*72,txt*72
c
      do i=1,72
        if (inp(i:i).ne.' ') goto 1
      end do
cccccccccccccccccccccccccccc
c     first value begins in position i
cccccccccccccccccccccccccccc
1     continue
      do j=i+1,72
        if (inp(j:j).eq.' ') goto 2
      end do
cccccccccccccccccccccccccccc
c     space after first value begins in position j
cccccccccccccccccccccccccccc
2     continue
      do k=j+1,72
        if (inp(k:k).ne.' ') goto 3
      end do
cccccccccccccccccccccccccccc
c     second value begins in position k
cccccccccccccccccccccccccccc
3     continue
      do l=k+1,72
        if (inp(l:l).eq.' ') goto 4
      end do
cccccccccccccccccccccccccccc
c     space after second value begins in position l
cccccccccccccccccccccccccccc
4     continue
      do m=l+1,72
        if (inp(m:m).ne.' ') goto 5
      end do
ccccccccccccccccccccccccccccccc
c     end of line
      dstep=0.
      return
cccccccccccccccccccccccccccc
c     third value begins in position m
cccccccccccccccccccccccccccc
5     continue
      txt=inp(m:72)
      read (txt,*) dstep
      RETURN
      END
      SUBROUTINE coeff(a,b,c,alfa,beta,gamma,
     *                 ar11,ar12,ar13,ar22,ar23,ar33,
     *                 a11,a12,a13,a22,a23,a33,vol)
c
c  coefficients of reciprocal space metric tenzor:ar11,...,ar33
c  coefficients of direct space metric tenzor:a11,...,a33
c  coefficients to transform absolute coordinates into
c               relative ones: p1, ..., p6
c
          pi=3.1415927
          arad=alfa*pi/180.
          brad=beta*pi/180.
          grad=gamma*pi/180.
          ca=cos(arad)
          cb=cos(brad)
          cg=cos(grad)
          sa=sin(arad)
          sb=sin(brad)
          sg=sin(grad)
          w=sqrt(1-ca*ca-cb*cb-cg*cg+2*ca*cb*cg)
          cappa=1-ca*ca-cb*cb-cg*cg+2*ca*cb*cg
          ww=a*b*c*cappa
          if (ww.eq.0) stop 'Wrong unit cell parameters'
          vol=a*b*c*w
          ar11=sa*sa/(a*a*cappa)
          ar12=(ca*cb-cg)/(a*b*cappa)
          ar13=(ca*cg-cb)/(a*c*cappa)
          ar22=(sb*sb)/(b*b*cappa)
          ar23=(cb*cg-ca)/(b*c*cappa)
          ar33=(sg*sg)/(c*c*cappa)
          a11=a*a
          a22=b*b
          a33=c*c
          a12=a*b*cg
          a13=a*c*cb
          a23=b*c*ca
      RETURN
      END
      SUBROUTINE multi(maxsym,nsym,symmat,maxref,
     *                kref,ih,ik,il,mult)
      dimension symmat(12,maxsym)
      dimension ih(maxref),ik(maxref),il(maxref),mult(maxref)
c
      DO i=1,kref
         m=0
         DO j=1,nsym
            iih=ih(i)*symmat(1,j)+ik(i)*symmat(4,j)+il(i)*symmat(7,j)
            iik=ih(i)*symmat(2,j)+ik(i)*symmat(5,j)+il(i)*symmat(8,j)
            iil=ih(i)*symmat(3,j)+ik(i)*symmat(6,j)+il(i)*symmat(9,j)
            if(iih.eq.ih(i).and.iik.eq.ik(i).and.iil.eq.il(i)) m=m+1
            iih=-iih
            iik=-iik
            iil=-iil
            if(iih.eq.ih(i).and.iik.eq.ik(i).and.iil.eq.il(i)) m=m+1
         END DO
         if (m.ne.0) m=2*nsym/m
         mult(i)=m
      END DO
      RETURN
      END
      SUBROUTINE rdspr(nuspr,nuprot,ngroup,maxsym,nsym,symmat,
     *                 ncszon,mxcszn,as1,as2,as3,bcsz1,bcsz2,bcsz3,
     *                 mxshft,nshift,shift,isenan,kaxes,naxes)
c       input of 'crystallographic tables' file
        character fnspr*80,txt*8
        dimension symmat(12,maxsym),shift(3,mxshft)
        integer as1(mxcszn),as2(mxcszn),as3(mxcszn)
        dimension bcsz1(mxcszn),bcsz2(mxcszn),bcsz3(mxcszn)
        dimension naxes(3)
        logical isenan
c
        fnspr='fam.itc'
        open(nuspr,file=fnspr)
c
10      continue
        read (nuspr,'(a8)',end=100) txt
        if (txt.ne.'NEWGROUP') goto 10
        read (nuspr,*,end=100) ngr
        if (ngr.ne.ngroup) goto 10
c
20      continue
        read (nuspr,*,end=200,err=200) nsym
        IF (nsym.gt.maxsym) THEN
            write(nuprot,'(1x,a44,i6)')
     *      '!!! Number of symmetries more then MAXSYM - ',nsym
            stop 'Number of symmetries is too large'
        END IF
        DO j=1,nsym
           read (nuspr,*,end=200,err=200) (symmat(i,j),i=1,12)
        END DO
        read (nuspr,*,end=200,err=200) ncszon
        IF (ncszon.gt.mxcszn) THEN
            write(nuprot,'(1x,a44,i6)')
     *      '!!! Number of c/s zones more then MAXCSZON - ',ncszon
            stop 'Number of c/s zones is too large'
        END IF
        DO i=1,ncszon
           read(nuspr,*,end=200,err=200)
     *          as1(i),as2(i),as3(i),bcsz1(i),bcsz2(i),bcsz3(i)
        END DO
        read (nuspr,*) kaxes
        if (kaxes.ne.0) read (nuspr,*) (naxes(i),i=1,kaxes)
        read (nuspr,*,end=200,err=200) nshift
        IF (nshift.gt.mxshft) THEN
            write(nuprot,'(1x,a51,i6)')
     *     '!!! Number of origin choices is more then MXSHFT - ',nshift
            stop 'Number of origin choices is too large'
        END IF
        DO i=1,nshift
          read(nuspr,*,end=200,err=200)shift(1,i),shift(2,i),shift(3,i)
        END DO
        read (nuspr,*,end=200,err=200) ienant
        isenan=ienant.eq.1
        close(nuspr)
      RETURN
100     continue
        write (nuprot,'(1x,a47)')
     *  'There is no such group in the reference file - ',ngroup
        stop 'There is no necessary group in the reference file'
200     continue
        write(nuprot,'(1x,a36)')'Invalid format of the reference file'
        stop 'Invalid format of the reference file'
      END
      SUBROUTINE dfnpoi(acell,bcell,ccell,dstep,
     *               kaxes,naxes,npoint,nnx,nny,nnz)
      dimension naxes(3)
      dimension ndop(67)
      data ndop/2, 4, 6,    8,   10,   12,   16,   18,   20,   24,
     *   30,   32,   36,   40,   48,   50,   54,   60,   64,   72,
     *   80,   90,   96,  100,  108,  120,  128,  144,  150,  160,
     *  162,  180,  192,  200,  216,  240,  250,  256,  270,  288,
     *  300,  320,  324,  360,  384,  400,  432,  450,  480,  486,
     *  500,  512,  540,  576,  600,  640,  648,  720,  750,  768,
     *  800,  810,  864,  900,  960,  972,0/
c
      mnp=0
      ndpdim=66
      ndop(67)=1000
      if (kaxes.eq.1) goto 10
      if (kaxes.eq.3) goto 100
      stop 'Error in DFNPOI: incorrect value KAXES'
c
10    continue
      nnx=2
      nny=2
      nnz=2
      nn=naxes(1)
      if (nn.eq.1) mnp=acell/dstep
      if (nn.eq.2) mnp=bcell/dstep
      if (nn.eq.3) mnp=ccell/dstep
      do i=1,ndpdim
         if (ndop(i).gt.mnp) goto 20
      end do
20    continue
      npoint=ndop(i)
      if (npoint.lt.64) npoint=64
      return
c
100   continue
      mnx=acell/dstep
      do i=1,ndpdim
         if (ndop(i).gt.mnx) goto 110
      end do
110   continue
      nnx=ndop(i)
      mny=bcell/dstep
      do i=1,ndpdim
         if (ndop(i).gt.mny) goto 120
      end do
120   continue
      nny=ndop(i)
      mnz=ccell/dstep
      do i=1,ndpdim
         if (ndop(i).gt.mnz) goto 130
      end do
130   continue
      nnz=ndop(i)
      RETURN
      END
c*********************************************************************
c **********                                        27 Oct 1997
c * OPTSH3 *                                        N.L.Lunina
c **********
c     This subroutine is designed to find the best aligment (the one
c     with maximal maps correlation) for two maps and to calculate
c     corresponding map correlation coefficient. The allowed map
c     transformations are :
c     - origin shifts (permitted by particular space group)
c         RO(r) -> RO'(r) = RO(r+t) ;
c     - enantiomorph changing (if permitted by particular space  group)
c         RO(r) -> RO'(r) = RO(-r)
c     - the map 'overturning' (if such possibility was specified when
c       calling the subroutine)
c         RO(r) -> RO'(r) = -RO(r)
c
c     The subroutine output contains the found map trasformation and
c     map correlation coefficient corresponding to the best alignment.
c
c     For some space groups FFT kernel package must be present.
c
c     REFERENCES
c     1. Lunin V.Yu. & Woolfson M.M. "Mean Phase Error and the Map
c        Correlation Coefficient", (1993) Acta Cryst. D49, 530-533
c     2. Lunin V.Yu. & Lunina N.L. "
c
c --------------------------------------------------------------------
c
      SUBROUTINE optsh3(kref,ih,ik,il,ss,itsflg,ssmish,ssmash,
     *          mult,f1,p1,f2,p2,nshift,shift,
     *          kaxes,naxes,npoint,nx,ny,nz,isenan,isovr,numes,
     *          wf,wphi,cor,mxcor,logen,logovr,xopt,yopt,zopt,ccmax)
c
c ****************
c   INPUT DATA :
c      STRUCTURE FACTORS INFORMATION:
c       *  ATTENTION ! an asymmetric part of structure factors set
c       *            ! only must be present; 000 - reflection must
c       *            ! not be present in the list;
c            kref -   number of independent reflections for the maps
c                     calculation;
c            ih(.), ik(.), il(.) - their indexes;( . = 1,...,kref);
c            ss(.) - their s**2 values ( s=lambda/2sin(teta) );
c            ssmish, ssmash
c            itsflg(.)  - only the reflections with
c                         ssmish <= ss(.) <= ssmash
c                         and itsflg(.)=1
c                     will be used to calculate correlation;
c            mult(.) - their multiplicities (the number of different
c                     reciprocal lattice points generated from
c                     particular indexes by the space group and
c                     Hermitian symmetry transformations;
c       *
c       * EXAMPLE
c       *  P222 : mult(.) = 8 for hkl
c       *                   4 for 0kl h0l hk0
c       *                   2 for h00 0k0 00l
c
c            f1(.), p1(.) - modules and phases (in radians) for the
c                     first (fixed) map calculation;
c            f2(.), p2(.) - modules and phases for the second
c                     (adjustible) map calculation;
c      PERMITTED TRANSFORMATIONS:
c       *  ATTENTION ! It is supposed that any possible shift is a sum
c       *             of one of specified STANDARD shifts plus, may be,
c       *             an ARBITRARY shift(s) along specified axes; all
c       *             such combinations are checked;
c       *                when arbitrary shifts are permitted they are
c       *             checked at the grid with specified sampling;
c       *
c            nshift - number of standard shifts;
c            shift(3,.) - their values (in relative coordinates);
c                     (. = 1,...,nshift);
c            kaxes -  number of directions for arbitrary shifts (it
c                     may be equal to 0, 1 or 3);
c            naxes -  for kaxes=1 it is order-number of the axes for
c                     arbitrary shifts in the list {x,y,z}; for other
c                     kaxes-values it may be any value;
c       *
c       * EXAMPLES
c       *   P222   :   kaxes=0
c       *              naxes=1 (not important)
c       *              nshift=8
c       *              shift=/ 0.,  0.,  0.,    0.5, 0.,  0.,
c       *                      0.,  0.5, 0.,    0.5, 0.5, 0.,
c       *                      0.,  0.,  0.5,   0.5, 0.,  0.5,
c       *                      0.,  0.5, 0.5,   0.5, 0.5, 0.5/
c       *
c       *   P21 (axes c is the rotation axes) :
c       *              kaxes=1
c       *              naxes=3
c       *              nshift=4
c       *              shift=/ 0.,  0.,  0.,    0.5, 0.,  0.,
c       *                      0.,  0.5, 0.,    0.5, 0.5, 0./
c       *
c       *   P21 (axes b is the rotation axes) :
c       *              kaxes=1
c       *              naxes=2
c       *              nshift=4
c       *              shift=/ 0.,  0.,  0.,    0.5, 0.,  0.,
c       *                      0.,  0.,  0.5,   0.5, 0., 0.5/
c       *
c       *    P1   :    kaxes=3
c       *              naxes=1 (not important)
c       *              nshift=1
c       *              shift=/ 0., 0., 0./
c       *
c            npoint - for kaxes=1 it is the number of sampling points
c                     when looking for optimal arbitrary shift; any
c                     value for other cases;
c            nx,ny,nz - for kaxes=3 they are numbers of sampling point
c                     along axes  when looking for optimal arbitrary
c                     shift; any values in other cases;
c            isenan - LOGICAL value; it is equal .true. if enantiomorph
c                     chainging is a permitted trasformation;
c            isovr  - LOGICAL value; it is equal .true.  if overturning
c                     is a permitted transformation;
c      MESSAGES FILE
c            numes  - unit number for messages following abnormal end;
c      WORK ARRAYS
c            wf(.),wphi(.) - are used with KAXES=3 only; in such case
c                     their length must be KREF, at least
c            cor(.) - its length must be at least
c                         2*nshift  when KAXES=0,
c                         2*npoint  when KAXES=1,
c                         nx*ny*nz  when KAXES=3;
c            mxcor   - the actual size of COR(.)-array;
c ***************
c   OUTPUT DATA:
c            logen   - LOGICAL, it is equal to .true. if the optimal
c                      transformation contains chainging of
c                      enantiomorph ;
c            logovr  - LOGICAL, it is equal to .true. if the optimal
c                      transformation contains map overturning;
c            xopt,yopt,zopt - optimal shifts along x, y, z;
c            ccmax -   maps correlation coefficient corresponding to
c                      the optimal alignment;
c       *
c       *  ATTENTION ! To have the best alignment p2(.)-phases must
c       *              be transformaed as the next:
c       *  p2(.) ->
c       *  sen*p2(.)-2*PI*[xopt*ih(.)+yopt*ik(.)+zopt*il(.)]+povr
c       *              where
c       *              sen  = !  1 for logen =.false.
c       *                     ! -1 for logen =.true.
c       *
c       *              povr = !  0   for logovr =.false.
c       *                     !  PI  for logovr =.true.
c       *
c*********************************************************************
c
      dimension f1(kref),f2(kref),p1(kref),p2(kref),mult(kref)
      dimension wf(kref),wphi(kref),itsflg(kref)
      dimension ih(kref),ik(kref),il(kref),ss(kref)
      dimension shift(3,nshift),cor(mxcor),sym(12)
      dimension kcont(5),shopt(3)
      logical isenan,logovr,isovr,logen
c
      twopi=3.1415927*2
      nsize=mxcor
      ar2=0.
      nn=0
      cminge=0.
      nminge=0
      cmaxge=0.
      nmaxge=0
      nminte=0
      nmaxte=0
      cminwe=0.
      nminwe=0
      cmaxwe=0
      nmaxwe=0
      nmaxe=0
      nmine=0
c
      if (kaxes.eq.0) goto 10
      if (kaxes.eq.1) goto 50
      if (kaxes.eq.3) goto 600
      write(numes,'(1x,a22)') 'OPTSHF: Error in KAXES'
      stop 'Error in KAXES'
c
10    continue
c
c               the case kaxes=0
c
      IF (mxcor.lt.2*nshift) THEN
          write (numes,'(1x,a30)') 'OPTSHF: Array COR is too small'
          stop 'OPTSHF: Array COR is too small'
      END IF
      DO i=1,nshift
         s1=0.
         s2=0.
         s3=0.
         s4=0.
         DO j=1,kref
         if(ss(j).ge.ssmish.and.ss(j).le.ssmash.and.itsflg(j).eq.1)then
            sw=(ih(j)*shift(1,i)+ik(j)*shift(2,i)+il(j)*shift(3,i))
            ar1=p2(j)-twopi*sw-p1(j)
            if (isenan) ar2=-p2(j)-twopi*sw-p1(j)
            s1=s1+mult(j)*f1(j)*f2(j)*cos(ar1)
            if (isenan) s4=s4+mult(j)*f1(j)*f2(j)*cos(ar2)
            s2=s2+mult(j)*f1(j)*f1(j)
            s3=s3+mult(j)*f2(j)*f2(j)
         end if
         END DO
         w=sqrt(abs(s2*s3))
         if (w.eq.0.) then
            cor(i)=0.
            if (isenan) cor(i+nshift)=0.
           else
            cor(i)=s1/w
            if (isenan) cor(i+nshift)=s4/w
         end if
      END DO
      IF (.not.isenan) THEN
         nn=nshift
        ELSE
         nn=2*nshift
      END IF
      cmin=cor(1)
      cmax=cor(1)
      nshmin=1
      nshmax=1
      DO i=1,nn
         IF (cor(i).lt.cmin) THEN
           cmin=cor(i)
           nshmin=i
         END IF
         IF (cor(i).gt.cmax) THEN
           cmax=cor(i)
           nshmax=i
         END IF
      END DO
      IF (nshmax.gt.nshift) THEN
          esmax=-1
          logen=.true.
          osxmax=shift(1,nshmax-nshift)
          osymax=shift(2,nshmax-nshift)
          oszmax=shift(3,nshmax-nshift)
         ELSE
          esmax=1.
          logen=.false.
          osxmax=shift(1,nshmax)
          osymax=shift(2,nshmax)
          oszmax=shift(3,nshmax)
      END IF
      IF (nshmin.gt.nshift) THEN
          esmin=-1
          logen=.true.
          osxmin=shift(1,nshmin-nshift)
          osymin=shift(2,nshmin-nshift)
          oszmin=shift(3,nshmin-nshift)
         ELSE
          esmin=1.
          logen=.false.
          osxmin=shift(1,nshmin)
          osymin=shift(2,nshmin)
          oszmin=shift(3,nshmin)
      END IF
c
      esopt=esmax
      xopt=osxmax
      yopt=osymax
      zopt=oszmax
      ccmax=cmax
      logovr=.false.
      IF (cmax.lt.-cmin.and.isovr) THEN
          esopt=esmin
          xopt=osxmin
          yopt=osymin
          zopt=oszmin
          logovr=.true.
          ccmax=-cmin
      END IF
      logen=esopt.eq.-1
      RETURN
50    continue
c
c                     the case   kaxes=1
c
      IF (mxcor.lt.2*npoint) THEN
          write (numes,'(1x,a30)') 'OPTSHF: Array COR is too small'
          stop 'OPTSHF: Array COR is too small'
      END IF
      step=1./npoint
      n2=npoint/2
      kcont(1)=npoint
      kcont(2)=2
      kcont(3)=npoint
      kcont(4)=npoint
      kcont(5)=npoint
c
      s1=0.
      s2=0.
      DO j=1,kref
        if (ss(j).ge.ssmish.and.ss(j).le.ssmash.and.itsflg(j).eq.1)then
         s1=s1+mult(j)*f1(j)*f1(j)
         s2=s2+mult(j)*f2(j)*f2(j)
        end if
      END DO
      w=sqrt(abs(s1*s2))
      alpha=0.
      if (w.ne.0.) alpha=1./w
c
      cming=+w
      nming=1
      cmaxg=-w
      nmaxg=1
      nmint=1
      nmaxt=1
      if (isenan) then
         cminge=+w
         nminge=1
         cmaxge=-w
         nmaxge=1
         nminte=1
         nmaxte=1
      end if
      DO i=1,nshift
         tx0=shift(1,i)
         ty0=shift(2,i)
         tz0=shift(3,i)
         DO ii=1,npoint
            cor(ii)=0.
            cor(ii+npoint)=0.
         END DO
c
         s1=0.
         s2=0.
         s3=0.
         s4=0.
         DO j=1,kref
         if(ss(j).ge.ssmish.and.ss(j).le.ssmash.and.itsflg(j).eq.1)then
            iih=ih(j)
            iik=ik(j)
            iil=il(j)
c
            nn=naxes
            if (nn.eq.1) jjl=iabs(iih)
            if (nn.eq.2) jjl=iabs(iik)
            if (nn.eq.3) jjl=iabs(iil)
c
            ff1=f1(j)
            ff2=f2(j)
            pp1=p1(j)
            pp2=p2(j)
            mw=mult(j)
            if (jjl.ne.0) mw=mw/2
            if (jjl.ge.npoint/2) then
                write(numes,'(1x,a17,i5)')'JJL is too large ',jjl
                stop 'JJL is too large'
            end if
            IF (jjl.ge.0) THEN
               ar1=pp2-pp1-twopi*(iih*tx0+iik*ty0+iil*tz0)
               cor(2*jjl+1)=cor(2*jjl+1)+mw*ff1*ff2*cos(ar1)
               cor(2*jjl+2)=cor(2*jjl+2)+mw*ff1*ff2*sin(ar1)
               if (isenan) then
                  ii=2*jjl+1+npoint
                  ar2=-pp2-pp1-twopi*(iih*tx0+iik*ty0+iil*tz0)
                  cor(ii)=cor(ii)+mw*ff1*ff2*cos(ar2)
                  cor(ii+1)=cor(ii+1)+mw*ff1*ff2*sin(ar2)
               end if
            END IF
          end if
         END DO
c
c
c        here FFT will be
c
c
         call HERMFT(cor(1),cor(2),n2,kcont,nsize)
         if (isenan)
     *     call HERMFT(cor(npoint+1),cor(npoint+2),n2,kcont,nsize)
c
         cminw=cor(1)
         nminw=1
         cmaxw=cor(1)
         nmaxw=1
         if (isenan) then
            cminwe=cor(npoint+1)
            nminwe=1
            cmaxwe=cor(npoint+1)
            nmaxwe=1
         end if
         DO ii=1,npoint
            IF (cor(ii).lt.cminw) THEN
                cminw=cor(ii)
                nminw=ii
            END IF
            IF (cor(ii).gt.cmaxw) THEN
                cmaxw=cor(ii)
                nmaxw=ii
            END IF
            IF (isenan) THEN
               IF (cor(ii+npoint).lt.cminwe) THEN
                   cminwe=cor(ii+npoint)
                   nminwe=ii
               END IF
               IF (cor(ii+npoint).gt.cmaxwe) THEN
                   cmaxwe=cor(ii+npoint)
                   nmaxwe=ii
               END IF
            END IF
         END DO
         IF (cmaxw.gt.cmaxg) THEN
            cmaxg=cmaxw
            nmaxg=i
            nmaxt=nmaxw
         END IF
         IF (cminw.lt.cming) THEN
            cming=cminw
            nming=i
            nmint=nminw
         END IF
         IF (isenan) THEN
            IF (cmaxwe.gt.cmaxge) THEN
               cmaxge=cmaxwe
               nmaxge=i
               nmaxte=nmaxwe
            END IF
            IF (cminwe.lt.cminge) THEN
               cminge=cminwe
               nminge=i
               nminte=nminwe
            END IF
         END IF
      END DO
c
      cming=cming*alpha
      cmaxg=cmaxg*alpha
      IF (isenan) THEN
         cminge=cminge*alpha
         cmaxge=cmaxge*alpha
      END IF
c
c     cmaxg  - maximal correlation
c     cmaxge - maximal correlation for enant.
c     cming  - minimal correlation
c     cminge - minimal correlation for enant.
c
c     nming, nminge - number of shift
c     nmaxg, nmaxge
c     nmint, nminte - number of point
c     nmaxt, nminte
c     logovr,xopt,yopt,zopt,esopt - for output
c
      IF (.not.isenan.and..not.isovr) goto 100
      IF (.not.isenan.and.isovr) goto 200
      IF (     isenan.and..not.isovr) goto 300
      IF (     isenan.and.isovr) goto 400
90    continue
      write (numes,'(1x,a23)') 'Logical error in OPTSHF'
      stop 'Logical error in OPTSHF'
c
c      .not.isenan.and..not.isovr
100   continue
         logovr=.false.
         logen=.false.
         ccmax=cmaxg
         nsh=nmaxg
         nt=nmaxt
      goto 500
c     .not.isenan.and.isovr
200   continue
         IF (cmaxg.gt.-cming) THEN
            logovr=.false.
            logen=.false.
            ccmax=cmaxg
            nsh=nmaxg
            nt=nmaxt
           ELSE
            logovr=.true.
            logen=.false.
            ccmax=-cming
            nsh=nming
            nt=nmint
         END IF
      goto 500
c     isenan.and..not.isovr
300   continue
         IF (cmaxg.gt.cmaxge) THEN
            logovr=.false.
            logen=.false.
            ccmax=cmaxg
            nsh=nmaxg
            nt=nmaxt
           ELSE
            logovr=.false.
            logen=.true.
            ccmax=cmaxge
            nsh=nmaxge
            nt=nmaxte
         END IF
      goto 500
c     isenan.and.isovr
400   continue
         logovr=.false.
         logen=.false.
         ccmax=cmaxg
         nsh=nmaxg
         nt=nmaxt
         IF (cmaxge.gt.ccmax) THEN
            logovr=.false.
            logen=.true.
            ccmax=cmaxge
            nsh=nmaxge
            nt=nmaxte
         END IF
         IF (-cming.gt.ccmax) THEN
            logovr=.true.
            logen=.false.
            ccmax=-cming
            nsh=nming
            nt=nmint
         END IF
         IF (-cminge.gt.ccmax) THEN
            logovr=.true.
            esopt=-1.
            logen=.true.
            ccmax=-cminge
            nsh=nminge
            nt=nminte
         END IF
500   continue
         DO i=1,3
           shopt(i)=shift(i,nsh)
           if (i.eq.nn) shopt(i)=shopt(i)+(nt-1)*step
         END DO
         xopt=shopt(1)
         yopt=shopt(2)
         zopt=shopt(3)
      RETURN
600   continue
c
c               the case kaxes=3
c
      IF (mxcor.lt.nx*ny*nz) THEN
          write (numes,'(1x,a30)') 'OPTSHF: Array COR is too small'
          stop 'OPTSHF: Array COR is too small'
      END IF
      nall=nx*ny*nz
      s1=0.
      s2=0.
      DO j=1,kref
       if (ss(j).ge.ssmish.and.ss(j).le.ssmash.and.itsflg(j).eq.1)then
         s1=s1+mult(j)*f1(j)*f1(j)
         s2=s2+mult(j)*f2(j)*f2(j)
       end if
      END DO
      w=sqrt(abs(s1*s2))
      alpha=0.
      if (w.ne.0.) alpha=1./w
      nsym=1
      do i=1,12
         sym(i)=0.
         if (i.eq.1.or.i.eq.5.or.i.eq.9) sym(i)=1.
      end do
c
      do i=1,kref
        if (ss(i).ge.ssmish.and.ss(i).le.ssmash.and.itsflg(i).eq.1)then
            wf(i)=f1(i)*f2(i)
            wphi(i)=p2(i)-p1(i)
          else
            wf(i)=0.
            wphi(i)=0.
        end if
      end do
      call FFT1(nsym,sym,kref,ih,ik,il,wf,wphi,nx,ny,nz,
     *                cor,numes)
c
      cmaxg=cor(1)
      nmax=1
      cming=cor(1)
      nmin=1
      DO i=1,nall
         if (cor(i).gt.cmaxg) then
             cmaxg=cor(i)
             nmax=i
         end if
         if (cor(i).lt.cming) then
             cming=cor(i)
             nmin=i
         end if
      END DO
      IF (isenan) THEN
         do i=1,kref
            wphi(i)=-p2(i)-p1(i)
         end do
         call FFT1(nsym,sym,kref,ih,ik,il,wf,wphi,nx,ny,nz,
     *                cor,numes)
         cmaxge=cor(1)
         nmaxe=1
         cminge=cor(1)
         nmine=1
         DO i=1,nall
            if (cor(i).gt.cmaxge) then
                cmaxge=cor(i)
                nmaxe=i
            end if
            if (cor(i).lt.cminge) then
                cminge=cor(i)
                nmine=i
            end if
         END DO
      END IF
c
      IF (.not.isenan.and..not.isovr) goto 1100
      IF (.not.isenan.and.isovr) goto 1200
      IF (     isenan.and..not.isovr) goto 1300
      IF (     isenan.and.isovr) goto 1400
1005  continue
      write (numes,'(1x,a23)') 'Logical error in OPTSHF'
      stop 'Logical error in OPTSHF'
c
c      .not.isenan.and..not.isovr
1100   continue
         logovr=.false.
         logen=.false.
         ccmax=cmaxg
         nimax=nmax
      goto 1500
c     .not.isenan.and.isovr
1200   continue
         IF (cmaxg.gt.-cming) THEN
            logovr=.false.
            logen=.false.
            ccmax=cmaxg
            nimax=nmax
           ELSE
            logovr=.true.
            logen=.false.
            ccmax=-cming
            nimax=nmin
         END IF
      goto 1500
c     isenan.and..not.isovr
1300   continue
         IF (cmaxg.gt.cmaxge) THEN
            logovr=.false.
            logen=.false.
            ccmax=cmaxg
            nimax=nmax
           ELSE
            logovr=.false.
            logen=.true.
            ccmax=cmaxge
            nimax=nmaxe
         END IF
      goto 1500
c     isenan.and.isovr
1400   continue
         logovr=.false.
         logen=.false.
         ccmax=cmaxg
         nimax=nmax
         IF (cmaxge.gt.ccmax) THEN
            logovr=.false.
            logen=.true.
            ccmax=cmaxge
            nimax=nmaxe
         END IF
         IF (-cming.gt.ccmax) THEN
            logovr=.true.
            logen=.false.
            ccmax=-cming
            nimax=nmin
         END IF
         IF (-cminge.gt.ccmax) THEN
            logovr=.true.
            logen=.true.
            ccmax=-cminge
            nimax=nmine
         END IF
1500   continue
c
c        nimax=(kmax-1)*(nx*ny)+(jmax-1)*nx+imax
c
         ccmax=ccmax*alpha
         kk=(nimax-1)/(nx*ny)
         kkk=nimax-kk*nx*ny
         nnn=(kkk-1)/nx
         imax=kkk-nnn*nx
         jmax=nnn+1
         kmax=kk+1
         xopt=(imax-1.)/nx
         yopt=(jmax-1.)/ny
         zopt=(kmax-1.)/nz
      RETURN
      END
c*********************************************************************

c********************************************************************
      SUBROUTINE outfil(nuout,nref,ih,ik,il,fobs,tstflg,fom,phave,
     *     tcalc,phcalc,isex,phex,pharad)
       integer ih(nref),ik(nref),il(nref)
       dimension fobs(nref),tstflg(nref),phex(nref)
       dimension fom(nref),phave(nref)
       dimension tcalc(nref),phcalc(nref)
       logical isex,pharad
c
       pi=3.1415927
       digrad=180./pi
       dd=1.e+10
c
       if(isex) then
          lrec=10
         else
          lrec=9
        end if
        write(nuout,'(i4)') lrec
c
        if(.not.pharad) then
           if (isex) then
              do i=1,nref
                 if (phex(i).ne.dd) phex(i)=phex(i)*digrad
              end do
           end if
           do i=1,nref
              phave(i)=phave(i)*digrad
              phcalc(i)=phcalc(i)*digrad
           end do
        end if
        do i=1,nref
          if (isex) then
             if (pharad) then
               write(nuout,1000) ih(i),ik(i),il(i),fobs(i),
     *         tstflg(i),fom(i),phave(i),tcalc(i),phcalc(i),phex(i)
              else
               write(nuout,1010) ih(i),ik(i),il(i),fobs(i),
     *         tstflg(i),fom(i),phave(i),tcalc(i),phcalc(i),phex(i)
              end if
            else
             if (pharad) then
               write(nuout,1000) ih(i),ik(i),il(i),fobs(i),
     *         tstflg(i),fom(i),phave(i),tcalc(i),phcalc(i)
              else
               write(nuout,1010) ih(i),ik(i),il(i),fobs(i),
     *         tstflg(i),fom(i),phave(i),tcalc(i),phcalc(i)
             end if
          end if
1000      format(3i4,5g12.6/(6g12.6))
1010      format(3i4,5g12.5/(6g12.5))
        end do
      RETURN
      END
      SUBROUTINE zphnor(phase,mode)
c
c        for mode=1 reduce the phase to [0,2*PI) interval
c        for mode=2 treats phase as a phase difference and reduce
c                   it to [0,PI] range.
c
      pi=3.1415927
      twopi=2.*pi
c
      w=amod(phase,twopi)
      if(w.lt.0.) w=w+twopi
c
      if(mode.eq.2) then
        if(w.gt.pi) w=twopi-w
      endif
c
      phase=w
      RETURN
      END
      SUBROUTINE digrad(nuprot,inps,phadef,pharad)
      character inps*72,sym*1
      logical phadef,pharad
c
      do i=1,72
         if(inps(i:i).ne.' ') goto 10
      end do
10    continue
c     non space
      k=i
      do i=k,72
         if(inps(i:i).eq.' ') goto 20
      end do
20    continue
c     space after digits
      k=i
      do i=k,72
         if(inps(i:i).ne.' ') goto 30
      end do
c     i.eq.72
      phadef=.false.
      return
30    continue
c     non space after digits
      phadef=.true.
      k=i
      sym=inps(k:k)
      if(sym.eq.'r') sym='R'
      if(sym.eq.'d') sym='D'
      if(sym.ne.'R'.and.sym.ne.'D') then
         write(nuprot,'(a37)')' Invalid value for RADIAN/DEGREE mode'
         stop ' Invalid value for RADIAN/DEGREE mode'
      end if
      pharad=sym.eq.'R'
      RETURN
      END
          SUBROUTINE intpha(kref,ph,pharad,phadef)
          dimension ph(kref)
          logical pharad,phadef
c
            summa=0.
            ave=0.
            do i=1,kref
               summa=summa+abs(ph(i))
            end do
            if (kref.ne.0) ave=summa/kref
            if(abs(ave).lt.5.) then
               pharad=.true.
               phadef=.true.
              elseif (abs(ave).ge.50.) then
               pharad=.false.
               phadef=.true.
              else
               phadef=.false.
          end if
          RETURN
          END
          SUBROUTINE chkint(nuprot,phadef,phadfp,pharad,phardp)
          logical phadef,phadfp,pharad,phardp,good
c
cccccccccccccccccccccccccccccccccccccccccccccccccccc
          if (.not.phadef.and..not.phadfp) goto 1001
          if (phadef.and..not.phadfp) goto 1002
          if (.not.phadef.and.phadfp) goto 1003
          if (phadef.and.phadfp) goto 1004
cccccccccccccccccccccccccccccccccccccccccccccccccccc
c          if (.not.phadef.and..not.phadfp) goto 1001
1001       continue
           write (nuprot,'(1x,a38/1x,a28)')
     *           'There is no RADIAN/DEGREE information.',
     *           'Phases can"t be interpreted.'
           stop 'Phases can"t be interpreted.'
cccccccccccccccccccccccccccccccccccccccccccccccccccc
c          if (phadef.and..not.phadfp) goto 1002
1002       continue
           write (nuprot,'(1x,a28/1x,a41)')
     *           'Phases can"t be interpreted.',
     *           'Input RADIAN/DEGREE information is in use'
           goto 1005
cccccccccccccccccccccccccccccccccccccccccccccccccccc
c          if (.not.phadef.and.phadfp) goto 1003
1003       continue
           if (phardp) then
            write(nuprot,'(a40)')
     *          ' Phases are interpreted to be in radians'
            pharad=.true.
           else
            write(nuprot,'(a40)')
     *          ' Phases are interpreted to be in degrees'
            pharad=.false.
           end if
           goto 1005
cccccccccccccccccccccccccccccccccccccccccccccccccccc
c          if (phadef.and.phadfp) goto 1004
1004       continue
           good=pharad.and.phardp.or..not.pharad.and..not.phardp
           if (good) goto 1005
           if(pharad.and..not.phardp) then
              write (nuprot,'(1x,a42/1x,a42/1x,a42/1x,a42/1x,a42)')
     *               '******************************************',
     *               '* Phases are defined in RADIANS,         *',
     *               '* but they are interpreted in DEGREES!!! *',
     *               '*           RADIANS are used !!!         *',
     *               '******************************************'
              write (*,'(1x,a42/1x,a42/1x,a42/1x,a42/1x,a42)')
     *               '******************************************',
     *               '* Phases are defined in RADIANS,         *',
     *               '* but they are interpreted in DEGREES!!! *',
     *               '*           RADIANS are used !!!         *',
     *               '******************************************'
           end if
           if(.not.pharad.and.phardp) then
              write (nuprot,'(1x,a42/1x,a42/1x,a42/1x,a42/1x,a42)')
     *               '******************************************',
     *               '* Phases are defined in DEGREES,         *',
     *               '* but they are interpreted in RADIANS!!! *',
     *               '*           DEGREES are used !!!         *',
     *               '******************************************'
              write (*,'(1x,a42/1x,a42/1x,a42/1x,a42/1x,a42)')
     *               '******************************************',
     *               '* Phases are defined in DEGREES,         *',
     *               '* but they are interpreted in RADIANS!!! *',
     *               '*           DEGREES are used !!!         *',
     *               '******************************************'
           end if
cccccccccccccccccccccccccccccccccccccccccccccccccccc
1005       continue
           RETURN
           END
c-----------------------------------------------------------------
      FUNCTION URAND(j)
c
c      dot from A.S.Mosunov 20.10.92
c
      REAL xj
      INTEGER m,a,irab
      PARAMETER (m=2147483647,a=16807,am=2147483648.)
      irab=j*a
      IF (irab.LT.0) irab=irab+m+1
      j=irab
      xj=FLOAT(j)/am
      urand=xj
      RETURN
      END
c*********************************************************************
      SUBROUTINE phsym(kref,ih,ik,il,kcs,a1,a2,a3,b1,b2,b3,
     *                 phi)
c
c         This subroutine is designe to change the values of
c         centric phases phi(.) for the nearest permissible ones
c
c         kref - number of reflections in the list
c         ih(.),ik(.),il(.) - their indexes
c         kcs - number of centrosymmetric zones
c         a1(.),a2(.),a3(.) - define c/s zones
c         b1(.),b2(.),b3(.) - define posiible phase value as
c                             (b1*ih+b2*ik+b3*il)*PI + {PI}
c
      integer a1(kcs),a2(kcs),a3(kcs)
      dimension ih(kref),ik(kref),il(kref),phi(kref)
      dimension b1(kcs),b2(kcs),b3(kcs)
      logical belong
c
      pi=3.1415927
      pi2=0.5*pi
c
      do k=1,kref
        belong=.false.
        do j=1,kcs
          if (.not.belong) then
          if(a1(j)*ih(k)+a2(j)*ik(k)+a3(j)*il(k).eq.0) then
            belong=.true.
            w=pi*(b1(j)*ih(k)+b2(j)*ik(k)+b3(j)*il(k))
            del=w-phi(k)
            CALL zphnor(del,2)
            if(del.le.pi2) then
                phi(k)=w
              else
                phi(k)=w+pi
            endif
          endif
          end if
        enddo
      enddo
c
      RETURN
      END
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c********************************************************************
c
c   January 19, 2004
c
c   FFT1m FFT1    FT1  and 1-dim kernel were modified
c   INTR  ZERO
c
c
c*********************************************************************
c********************************************************************
c
c       ONE - DIMENSIONAL FAST FOURIER TRANSFORM
c       by L.Ten Eyck
c
c
c  modified by VL on January 19, 2004  - warning messages were calmed
c
c
c********************************************************************
C     fft033
c
      SUBROUTINE HERM FT (X, Y, N, DIM,nsize)
      INTEGER N
      INTEGER DIM(5)
      REAL X(1), Y(1)
C
C     HERMITIAN SYMMETRIC FOURIER TRANSFORM
C
C     GIVEN THE UNIQUE TERMS OF A HERMITIAN SYMMETRIC SEQUENCE OF LENGTH
C     2N THIS SUBROUTINE CALCULATES THE 2N REAL NUMBERS WHICH ARE ITS
C     FOURIER TRANSFORM.  THE EVEN NUMBERED ELEMENTS OF THE TRANSFORM
C     (0, 2, 4, . . ., 2N-2) ARE RETURNED IN X AND THE ODD NUMBERED
C     ELEMENTS (1, 3, 5, . . ., 2N-1) IN Y.
C
C     A FINITE HERMITIAN SEQUENCE OF LENGTH 2N CONTAINS N + 1 UNIQUE
C     REAL NUMBERS AND N - 1 UNIQUE IMAGINARY NUMBERS.  FOR CONVENIENCE
C     THE REAL VALUE FOR X(N) IS STORED AT Y(0).
C
      REAL A, B, C, D, E, F, ANGLE, CO, SI, TWO N, TWO PI
      INTEGER NT, D2, D3, D4, D5
      INTEGER I, J, K, N OVER 2, I0, I1, I2
      INTEGER K1
C
      TWO PI = 6.283185
      TWO N = FLOAT(2*N)
C
      NT = DIM(1)
      D2 = DIM(2)
      D3 = DIM(3)
      D4 = DIM(4) - 1
      D5 = DIM(5)
C
      DO 100 I0 = 1, NT, D3
      I1 = I0 + D4
      DO 100 I = I0, I1, D5
      A = X(I)
      B = Y(I)
      X(I) = A + B
      Y(I) = A - B
  100 CONTINUE
C
      N OVER 2 = N/2 + 1
      IF (N OVER 2 .LT. 2) GO TO 500
      DO 400 I0 = 2, N OVER 2
      ANGLE = TWO PI*FLOAT(I0-1)/TWO N
      CO = COS(ANGLE)
      SI = SIN(ANGLE)
      K = (N + 2 - 2*I0)*D2
      K1 = (I0 - 1)*D2 + 1
      DO 300 I1 = K1, NT, D3
      I2 = I1 + D4
      DO 200 I = I1, I2, D5
      J = I + K
      A = X(I) + X(J)
      B = X(I) - X(J)
      C = Y(I) + Y(J)
      D = Y(I) - Y(J)
      E = B*CO + C*SI
      F = B*SI - C*CO
      X(I) = A + F
      X(J) = A - F
      Y(I) = E + D
      Y(J) = E - D
  200 CONTINUE
  300 CONTINUE
  400 CONTINUE
C
      CALL CMPL FT (X, Y, N, DIM,nsize)
C
  500 CONTINUE
      RETURN
C
      END
c
c--------------------------------------------------------------------
C     FFT038
C
      SUBROUTINE CMPL FT (X, Y, N, D,nl)
      INTEGER N
      INTEGER D(5)
      REAL X(1), Y(1)
C
C     COMPLEX FINITE DISCRETE FOURIER TRANSFORM
C     TRANSFORMS ONE DIMENSION OF MULTI-DIMENSIONAL DATA
C     MODIFIED BY L. F. TEN EYCK FROM A ONE-DIMENSIONAL VERSION WRITTEN
C     BY G. T. SANDE, 1969.
C
C     THIS PROGRAM CALCULATES THE TRANSFORM
C               (X(T) + I*Y(T))*(COS(2*PI*T/N) - I*SIN(2*PI*T/N))
C
C     INDEXING -- THE ARRANGEMENT OF THE MULTI-DIMENSIONAL DATA IS
C     SPECIFIED BY THE INTEGER ARRAY D, THE VALUES OF WHICH ARE USED AS
C     CONTROL PARAMETERS IN DO LOOPS.  WHEN IT IS DESIRED TO COVER ALL
C     ELEMENTS OF THE DATA FOR WHICH THE SUBSCRIPT BEING TRANSFORMED HAS
C     THE VALUE I0, THE FOLLOWING IS USED.
C
C               I1 = (I0 - 1)*D(2) + 1
C               DO 100 I2 = I1, D(1), D(3)
C               I3 = I2 + D(4) - 1
C               DO 100 I = I2, I3, D(5)
C                  .
C                  .
C           100 CONTINUE
C
C     WITH THIS INDEXING IT IS POSSIBLE TO USE A NUMBER OF ARRANGEMENTS
C     OF THE DATA, INCLUDING NORMAL FORTRAN COMPLEX NUMBERS (D(5) = 2)
C     OR SEPARATE STORAGE OF REAL AND IMAGINARY PARTS.
C
      LOGICAL ERROR
      INTEGER P MAX, P SYM, TWO GRP
      INTEGER FACTOR(15), SYM(15), UN SYM(15)
C
C     P MAX IS THE LARGEST PRIME FACTOR THAT WILL BE TOLERATED BY THIS
C     PROGRAM.
C     TWO GRP IS THE LARGEST POWER OF TWO THAT IS TREATED AS A SPECIAL
C     CASE.
C
      P MAX = 19
      TWO GRP = 8
C
      IF (N .LE. 1) GO TO 100
      CALL S R FP (N, P MAX, TWO GRP, FACTOR, SYM, P SYM, UN SYM, ERROR)
      IF (ERROR) GO TO 200
C
      CALL MD FT KD (N, FACTOR, D, X, Y,nl)
      CALL D IP RP (N, SYM, P SYM, UN SYM, D, X, Y,nl)
C
  100 CONTINUE
      RETURN
C
  200 CONTINUE
      WRITE (3,300) N
      STOP
C
  300 FORMAT (43H0INVALID NUMBER OF POINTS FOR CMPL FT.  N =, I10//)
C
      END
c
c--------------------------------------------------------------------
C     FFT039
C
      SUBROUTINE S R FP (PTS,PMAX,TWO GRP,FACTOR,SYM,P SYM,UN SYM,ERROR)
C     SYMMETRIZED REORDERING FACTORING PROGRAMME
C
      LOGICAL ERROR
      INTEGER PTS,PMAX,TWO GRP,P SYM
      INTEGER FACTOR (10), SYM (10), UN SYM (10)
C
      INTEGER PP(14), QQ (7)
      INTEGER F,J,JJ,N,NEST,P,P TWO,Q,R
C
      NEST=14
C
      N=PTS
      P SYM=1
      F=2
      P=0
      Q=0
  100 CONTINUE
      IF (N.LE.1) GO TO 500
      DO 200 J=F,PMAX
      IF (N.EQ.(N/J)*J) GO TO 300
  200 CONTINUE
      GO TO 1400
  300 CONTINUE
      IF (2*P+Q.GE.NEST) GO TO 1600
      F=J
      N=N/F
      IF (N.EQ.(N/F)*F) GO TO 400
      Q=Q+1
      QQ(Q)=F
      GO TO 100
  400 CONTINUE
      N=N/F
      P=P+1
      PP(P)=F
      P SYM=P SYM*F
      GO TO 100
C
  500 CONTINUE
      R=1
      IF (Q.EQ.0) R=0
      IF (P.LT.1) GO TO 700
      DO 600 J=1,P
      JJ=P+1-J
      SYM(J)=PP(JJ)
      FACTOR(J)=PP(JJ)
      JJ=P+Q+J
      FACTOR(JJ)=PP(J)
      JJ=P+R+J
      SYM(JJ)=PP(J)
  600 CONTINUE
  700 CONTINUE
      IF (Q.LT.1) GO TO 900
      DO 800 J=1,Q
      JJ=P+J
      UN SYM(J)=QQ(J)
      FACTOR(JJ)=QQ(J)
  800 CONTINUE
      SYM(P+1)=PTS/P SYM**2
  900 CONTINUE
      JJ=2*P+Q
      FACTOR(JJ+1)=0
      P TWO=1
      J=0
 1000 CONTINUE
      J=J+1
      IF (FACTOR(J).EQ.0) GO TO 1200
      IF (FACTOR(J).NE.2) GO TO 1000
      P TWO=P TWO*2
      FACTOR(J)=1
      IF (P TWO.GE.TWO GRP) GO TO 1100
      IF (FACTOR(J+1).EQ.2) GO TO 1000
 1100 CONTINUE
      FACTOR(J)=P TWO
      P TWO=1
      GO TO 1000
 1200 CONTINUE
      IF (P.EQ.0) R=0
      JJ=2*P+R
      SYM(JJ+1)=0
      IF (Q.LE.1) Q=0
      UN SYM(Q+1)=0
      ERROR=.FALSE.
C
 1300 CONTINUE
      goto 1800
C
 1400 CONTINUE
      WRITE (3,1500) PMAX, PTS
      ERROR=.TRUE.
      GO TO 1300
 1500 FORMAT (24H0LARGEST FACTOR EXCEEDS ,I3,7H.  N = ,I6,1H.)
C
 1600 CONTINUE
      WRITE (3,1700) NEST, PTS
      ERROR=.TRUE.
      GO TO 1300
 1700 FORMAT (22H0FACTOR COUNT EXCEEDS ,I3,7H.  N = ,I6,1H.)
C
1800  continue
      return
      END
c
c--------------------------------------------------------------------
C     FFT040
C
      SUBROUTINE D IP RP (PTS,SYM,P SYM,UN SYM,DIM,X,Y,nla)
C     DOUBLE IN PLACE REORDERING PROGRAMME
C
      INTEGER PTS,P SYM
      REAL X(nla), Y(nla)
      INTEGER SYM(10), UN SYM(10), DIM(5)
C
      REAL T
      LOGICAL ONE MOD
      INTEGER MODULO (14)
      INTEGER DK,JJ,KK,LK,MODS,MULT,NEST,P UN SYM,TEST
      INTEGER NT, SEP, DELTA, P, P0, P1, P2, P3, P4, P5, SIZE
C
      INTEGER S (14), U (14)
      INTEGER A,B,C,D,E,F,G,H,I,J,K,L,M,N
      INTEGER BS,CS,DS,ES,FS,GS,HS,IS,JS,KS,LS,MS,NS
      INTEGER AL,BL,CL,DL,EL,FL,GL,HL,IL,JL,KL,LL,ML,NL
      EQUIVALENCE           (AL,U(1)),(BS,S(2)),(BL,U(2))
      EQUIVALENCE (CS,S(3)),(CL,U(3)),(DS,S(4)),(DL,U(4))
      EQUIVALENCE (ES,S(5)),(EL,U(5)),(FS,S(6)),(FL,U(6))
      EQUIVALENCE (GS,S(7)),(GL,U(7)),(HS,S(8)),(HL,U(8))
      EQUIVALENCE (IS,S(9)),(IL,U(9)),(JS,S(10)),(JL,U(10))
      EQUIVALENCE (KS,S(11)),(KL,U(11)),(LS,S(12)),(LL,U(12))
      EQUIVALENCE (MS,S(13)),(ML,U(13)),(NS,S(14)),(NL,U(14))
C
      data MODS /0/
c
      NEST=14
C
      NT = DIM(1)
      SEP = DIM(2)
      P2 = DIM(3)
      SIZE = DIM(4) - 1
      P4 = DIM(5)
      IF (SYM(1).EQ.0) GO TO 500
      DO 100 J=1,NEST
      U(J)=1
      S(J)=1
  100 CONTINUE
      N=PTS
      DO 200 J=1,NEST
      IF (SYM(J).EQ.0) GO TO 300
      JJ=NEST+1-J
      U(JJ)=N
      S(JJ)=N/SYM(J)
      N=N/SYM(J)
  200 CONTINUE
  300 CONTINUE
C
      JJ=0
      DO 400 A=1,AL
      DO 400 B=A,BL,BS
      DO 400 C=B,CL,CS
      DO 400 D=C,DL,DS
      DO 400 E=D,EL,ES
      DO 400 F=E,FL,FS
      DO 400 G=F,GL,GS
      DO 400 H=G,HL,HS
      DO 400 I=H,IL,IS
      DO 400 J=I,JL,JS
      DO 400 K=J,KL,KS
      DO 400 L=K,LL,LS
      DO 400 M=L,ML,MS
      DO 400 N=M,NL,NS
      JJ=JJ+1
      IF (JJ.GE.N) GO TO 400
      DELTA = (N-JJ)*SEP
      P1 = (JJ-1)*SEP + 1
      DO 350 P0 = P1, NT, P2
      P3 = P0 + SIZE
      DO 350 P = P0, P3, P4
      P5 = P + DELTA
      T = X(P)
      X(P) = X(P5)
      X(P5) = T
      T = Y(P)
      Y(P) = Y(P5)
      Y(P5) = T
  350 CONTINUE
  400 CONTINUE
C
  500 CONTINUE
      IF (UN SYM(1).EQ.0) GO TO 1900
      P UN SYM=PTS/P SYM**2
      MULT=P UN SYM/UN SYM(1)
      TEST=(UN SYM(1)*UN SYM(2)-1)*MULT*P SYM
      LK=MULT
      DK=MULT
      DO 600 K=2,NEST
      IF (UN SYM(K).EQ.0) GO TO 700
      LK=LK*UN SYM(K-1)
      DK=DK/UN SYM(K)
      U(K)=(LK-DK)*P SYM
      MODS=K
  600 CONTINUE
  700 CONTINUE
      ONE MOD=MODS.LT.3
      IF (ONE MOD) GO TO 900
      DO 800 J=3,MODS
      JJ=MODS+3-J
      MODULO(JJ)=U(J)
  800 CONTINUE
  900 CONTINUE
      MODULO(2)=U(2)
      JL=(P UN SYM-3)*P SYM
      MS=P UN SYM*P SYM
C
      DO 1800 J=P SYM,JL,P SYM
      K=J
C
 1000 CONTINUE
      K=K*MULT
      IF (ONE MOD) GO TO 1200
      DO 1100 I=3,MODS
      K=K-(K/MODULO(I))*MODULO(I)
 1100 CONTINUE
 1200 CONTINUE
      IF (K.GE.TEST) GO TO 1300
      K=K-(K/MODULO(2))*MODULO(2)
      GO TO 1400
 1300 CONTINUE
      K=K-(K/MODULO(2))*MODULO(2)+MODULO(2)
 1400 CONTINUE
      IF (K.LT.J) GO TO 1000
C
      IF (K.EQ.J) GO TO 1700
      DELTA = (K-J)*SEP
      DO 1600 L=1,P SYM
      DO 1500 M=L,PTS,MS
      P1 = (M+J-1)*SEP + 1
      DO 1500 P0 = P1, NT, P2
      P3 = P0 + SIZE
      DO 1500 JJ = P0, P3, P4
      KK = JJ + DELTA
      T=X(JJ)
      X(JJ)=X(KK)
      X(KK)=T
      T=Y(JJ)
      Y(JJ)=Y(KK)
      Y(KK)=T
 1500 CONTINUE
 1600 CONTINUE
 1700 CONTINUE
 1800 CONTINUE
C
 1900 CONTINUE
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT041
C
      SUBROUTINE MD FT KD (N, FACTOR, DIM, X, Y,nl)
C     MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL DRIVER
C
      INTEGER N
      INTEGER FACTOR (10), DIM(5)
      REAL X(nl), Y(nl)
C
      INTEGER F, M, P, R, S
C
      S = DIM(2)
      F = 0
      M = N
  100 CONTINUE
      F = F + 1
      P = FACTOR(F)
      IF (P.EQ.0) RETURN
      M = M/P
      R = M*S
      IF (P.GT.8) GO TO 700
      GO TO (100, 200, 300, 400, 500, 800, 700, 600), P
      GO TO 800
C
  200 CONTINUE
      CALL R2 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), DIM,nl)
      GO TO 100
C
  300 CONTINUE
      CALL R3 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., DIM,nl)
      GO TO 100
C
  400 CONTINUE
      CALL R4 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), DIM,nl)
      GO TO 100
C
  500 CONTINUE
      CALL R5 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), X(4*R+1), Y(4*R+1), DIM,nl)
      GO TO 100
C
  600 CONTINUE
      CALL R8 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), X(4*R+1), Y(4*R+1), X(5*R+1), Y(5*R+1),
     .X(6*R+1), Y(6*R+1), X(7*R+1), Y(7*R+1), DIM,nl)
      GO TO 100
C
  700 CONTINUE
      CALL RP CFTK (N, M, P, R, X, Y, DIM)
      GO TO 100
C
  800 CONTINUE
      WRITE (3,900)
      RETURN
  900 FORMAT (34H0TRANSFER ERROR DETECTED IN MDFTKD,//)
      END
c
c--------------------------------------------------------------------
C     FFT042
C
      SUBROUTINE R2 CFTK (N, M, X0, Y0, X1, Y1, DIM,nl)
C     RADIX 2 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, DIM(5)
      REAL X0(nl), Y0(nl), X1(nl), Y1(nl)
C
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M2,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM2, NT, SIZE, SEP
      INTEGER NS
      REAL ANGLE,C,IS,IU,RS,RU,S,TWOPI
      REAL FJM1, FM2
      DATA TWO PI/6.283185/
c
      data C,S /0.,0./
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M2=M*2
      FM2 = FLOAT(M2)
      M OVER 2=M/2+1
      MM2 = SEP*M2
C
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM2
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C=COS(ANGLE)
      S=SIN(ANGLE)
      GO TO 200
  100 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      C=-C
  200 CONTINUE
C
      DO 500 KK = K0, NS, MM2
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      RS=X0(K)+X1(K)
      IS=Y0(K)+Y1(K)
      RU=X0(K)-X1(K)
      IU=Y0(K)-Y1(K)
      X0(K)=RS
      Y0(K)=IS
      IF (ZERO) GO TO 300
      X1(K)=RU*C+IU*S
      Y1(K)=IU*C-RU*S
      GO TO 400
  300 CONTINUE
      X1(K)=RU
      Y1(K)=IU
  400 CONTINUE
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT043
C
      SUBROUTINE R3 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, DIM,nl)
C     RADIX 3 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, DIM(5)
      REAL X0(nl),Y0(nl),X1(nl),Y1(nl),
     * X2(nl), Y2(nl)
C
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M3,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM3, NT, SIZE, SEP
      INTEGER NS
      REAL ANGLE,A,B,C1,C2,S1,S2,T,TWOPI
      REAL I0,I1,I2,IA,IB,IS,R0,R1,R2,RA,RB,RS
      REAL FJM1, FM3
      DATA TWO PI/6.2831853/,A/-0.5/, B/0.86602540/
C
      data c1,c2,s1,s2 /0.,0.,0.,0./
c
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M3=M*3
      FM3 = FLOAT(M3)
      MM3 = SEP*M3
      M OVER 2=M/2+1
C
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM3
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      GO TO 200
  100 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=C1*A+S1*B
      S1=C1*B-S1*A
      C1=T
      T=C2*A-S2*B
      S2=-C2*B-S2*A
      C2=T
  200 CONTINUE
C
      DO 500 KK = K0, NS, MM3
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      R0=X0(K)
      I0=Y0(K)
      RS=X1(K)+X2(K)
      IS=Y1(K)+Y2(K)
      X0(K)=R0+RS
      Y0(K)=I0+IS
      RA=R0+RS*A
      IA=I0+IS*A
      RB=(X1(K)-X2(K))*B
      IB=(Y1(K)-Y2(K))*B
      IF (ZERO) GO TO 300
      R1=RA+IB
      I1=IA-RB
      R2=RA-IB
      I2=IA+RB
      X1(K)=R1*C1+I1*S1
      Y1(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      GO TO 400
  300 CONTINUE
      X1(K)=RA+IB
      Y1(K) = IA-RB
      X2(K)=RA-IB
      Y2(K) = IA + RB
  400 CONTINUE
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT044
C
      SUBROUTINE R4 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, DIM,nl)
C     RADIX 4 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, DIM(5)
      REAL X0(nl), Y0(nl), X1(nl), Y1(nl)
      REAL X2(nl), Y2(nl), X3(nl), Y3(nl)
C
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M4,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM4, NT, SIZE, SEP
      INTEGER NS
      REAL ANGLE,C1,C2,C3,S1,S2,S3,T,TWOPI
      REAL I1,I2,I3,IS0,IS1,IU0,IU1,R1,R2,R3,RS0,RS1,RU0,RU1
      REAL FJM1, FM4
      DATA TWO PI/6.283185/
C
      data c1,c2,c3,s1,s2,s3 /0.,0.,0.,0.,0.,0/
c
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M4=M*4
      FM4 = FLOAT(M4)
      MM4 = SEP*M4
      M OVER 2=M/2+1
C
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM4
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      C3=C2*C1-S2*S1
      S3=S2*C1+C2*S1
      GO TO 200
  100 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=C1
      C1=S1
      S1=T
      C2=-C2
      T=C3
      C3=-S3
      S3=-T
  200 CONTINUE
C
      DO 500 KK = K0, NS, MM4
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      RS0=X0(K)+X2(K)
      IS0=Y0(K)+Y2(K)
      RU0=X0(K)-X2(K)
      IU0=Y0(K)-Y2(K)
      RS1=X1(K)+X3(K)
      IS1=Y1(K)+Y3(K)
      RU1=X1(K)-X3(K)
      IU1=Y1(K)-Y3(K)
      X0(K)=RS0+RS1
      Y0(K)=IS0+IS1
      IF (ZERO) GO TO 300
      R1=RU0+IU1
      I1=IU0-RU1
      R2=RS0-RS1
      I2=IS0-IS1
      R3=RU0-IU1
      I3=IU0+RU1
      X2(K)=R1*C1+I1*S1
      Y2(K)=I1*C1-R1*S1
      X1(K)=R2*C2+I2*S2
      Y1(K)=I2*C2-R2*S2
      X3(K)=R3*C3+I3*S3
      Y3(K)=I3*C3-R3*S3
      GO TO 400
  300 CONTINUE
      X2(K)=RU0+IU1
      Y2(K)=IU0-RU1
      X1(K)=RS0-RS1
      Y1(K)=IS0-IS1
      X3(K)=RU0-IU1
      Y3(K)=IU0+RU1
  400 CONTINUE
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT045
C
      SUBROUTINE R5 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4,
     . DIM,nl)
C     RADIX 5 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, DIM(5)
      REAL X0(nl), Y0(nl), X1(nl), Y1(nl),
     *   X2(nl), Y2(nl)
      REAL X3(nl), Y3(nl), X4(nl), Y4(nl)
C
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M5,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM5, NT, SIZE, SEP
      INTEGER NS
      REAL ANGLE,A1,A2,B1,B2,C1,C2,C3,C4,S1,S2,S3,S4,T,TWOPI
      REAL R0,R1,R2,R3,R4,RA1,RA2,RB1,RB2,RS1,RS2,RU1,RU2
      REAL I0,I1,I2,I3,I4,IA1,IA2,IB1,IB2,IS1,IS2,IU1,IU2
      REAL FJM1, FM5
      DATA TWO PI/6.283185/, A1/0.30901699/, B1/0.95105652/,
     .      A2/-0.80901699/, B2/0.58778525/
C
      data c1,c2,c3,c4,s1,s2,s3,s4 /0.,0.,0.,0.,0.,0.,0.,0./
c
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M5=M*5
      FM5 = FLOAT(M5)
      MM5 = SEP*M5
      M OVER 2=M/2+1
C
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM5
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      C3=C2*C1-S2*S1
      S3=S2*C1+C2*S1
      C4=C2*C2-S2*S2
      S4=S2*C2+C2*S2
      GO TO 200
  100 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=C1*A1+S1*B1
      S1=C1*B1-S1*A1
      C1=T
      T=C2*A2+S2*B2
      S2=C2*B2-S2*A2
      C2=T
      T=C3*A2-S3*B2
      S3=-C3*B2-S3*A2
      C3=T
      T=C4*A1-S4*B1
      S4=-C4*B1-S4*A1
      C4=T
  200 CONTINUE
C
      DO 500 KK = K0, NS, MM5
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      R0=X0(K)
      I0=Y0(K)
      RS1=X1(K)+X4(K)
      IS1=Y1(K)+Y4(K)
      RU1=X1(K)-X4(K)
      IU1=Y1(K)-Y4(K)
      RS2=X2(K)+X3(K)
      IS2=Y2(K)+Y3(K)
      RU2=X2(K)-X3(K)
      IU2=Y2(K)-Y3(K)
      X0(K)=R0+RS1+RS2
      Y0(K)=I0+IS1+IS2
      RA1=R0+RS1*A1+RS2*A2
      IA1=I0+IS1*A1+IS2*A2
      RA2=R0+RS1*A2+RS2*A1
      IA2=I0+IS1*A2+IS2*A1
      RB1=RU1*B1+RU2*B2
      IB1=IU1*B1+IU2*B2
      RB2=RU1*B2-RU2*B1
      IB2=IU1*B2-IU2*B1
      IF (ZERO) GO TO 300
      R1=RA1+IB1
      I1=IA1-RB1
      R2=RA2+IB2
      I2=IA2-RB2
      R3=RA2-IB2
      I3=IA2+RB2
      R4=RA1-IB1
      I4=IA1+RB1
      X1(K)=R1*C1+I1*S1
      Y1(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      X3(K)=R3*C3+I3*S3
      Y3(K)=I3*C3-R3*S3
      X4(K)=R4*C4+I4*S4
      Y4(K)=I4*C4-R4*S4
      GO TO 400
  300 CONTINUE
      X1(K)=RA1+IB1
      Y1(K)=IA1-RB1
      X2(K)=RA2+IB2
      Y2(K)=IA2-RB2
      X3(K)=RA2-IB2
      Y3(K)=IA2+RB2
      X4(K)=RA1-IB1
      Y4(K)=IA1+RB1
  400 CONTINUE
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT046
C
      SUBROUTINE R8 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4,
     . X5, Y5, X6, Y6, X7, Y7, DIM,nl)
C     RADIX 8 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, DIM(5)
      REAL X0(nl),Y0(nl), X1(nl),
     *    Y1(nl), X2(nl), Y2(nl)
      REAL X3(nl), Y3(nl), X4(nl),
     *   Y4(nl), X5(nl), Y5(nl)
      REAL X6(nl), Y6(nl), X7(nl), Y7(nl)
C
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M8,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM8, NT, SIZE, SEP
      INTEGER NS
      REAL ANGLE,C1,C2,C3,C4,C5,C6,C7,E,S1,S2,S3,S4,S5,S6,S7,T,TWOPI
      REAL R1,R2,R3,R4,R5,R6,R7,RS0,RS1,RS2,RS3,RU0,RU1,RU2,RU3
      REAL I1,I2,I3,I4,I5,I6,I7,IS0,IS1,IS2,IS3,IU0,IU1,IU2,IU3
      REAL RSS0,RSS1,RSU0,RSU1,RUS0,RUS1,RUU0,RUU1
      REAL ISS0,ISS1,ISU0,ISU1,IUS0,IUS1,IUU0,IUU1
      REAL FJM1, FM8
      DATA TWO PI/6.283185/, E/0.70710678/
C
      data c1,c2,c3,c4,c5,c6,c7 /0.,0.,0.,0.,0.,0.,0./
      data s1,s2,s3,s4,s5,s6,s7 /0.,0.,0.,0.,0.,0.,0./
c
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M8=M*8
      FM8 = FLOAT(M8)
      MM8 = SEP*M8
      M OVER 2=M/2+1
C
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM8
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      C3=C2*C1-S2*S1
      S3=S2*C1+C2*S1
      C4=C2*C2-S2*S2
      S4=S2*C2+C2*S2
      C5=C4*C1-S4*S1
      S5=S4*C1+C4*S1
      C6=C4*C2-S4*S2
      S6=S4*C2+C4*S2
      C7=C4*C3-S4*S3
      S7=S4*C3+C4*S3
      GO TO 200
  100 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=(C1+S1)*E
      S1=(C1-S1)*E
      C1=T
      T=S2
      S2=C2
      C2=T
      T=(-C3+S3)*E
      S3=(C3+S3)*E
      C3=T
      C4=-C4
      T=-(C5+S5)*E
      S5=(-C5+S5)*E
      C5=T
      T=-S6
      S6=-C6
      C6=T
      T=(C7-S7)*E
      S7=-(C7+S7)*E
      C7=T
  200 CONTINUE
C
      DO 500 KK = K0, NS, MM8
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      RS0=X0(K)+X4(K)
      IS0=Y0(K)+Y4(K)
      RU0=X0(K)-X4(K)
      IU0=Y0(K)-Y4(K)
      RS1=X1(K)+X5(K)
      IS1=Y1(K)+Y5(K)
      RU1=X1(K)-X5(K)
      IU1=Y1(K)-Y5(K)
      RS2=X2(K)+X6(K)
      IS2=Y2(K)+Y6(K)
      RU2=X2(K)-X6(K)
      IU2=Y2(K)-Y6(K)
      RS3=X3(K)+X7(K)
      IS3=Y3(K)+Y7(K)
      RU3=X3(K)-X7(K)
      IU3=Y3(K)-Y7(K)
      RSS0=RS0+RS2
      ISS0=IS0+IS2
      RSU0=RS0-RS2
      ISU0=IS0-IS2
      RSS1=RS1+RS3
      ISS1=IS1+IS3
      RSU1=RS1-RS3
      ISU1=IS1-IS3
      RUS0=RU0-IU2
      IUS0=IU0+RU2
      RUU0=RU0+IU2
      IUU0=IU0-RU2
      RUS1=RU1-IU3
      IUS1=IU1+RU3
      RUU1=RU1+IU3
      IUU1=IU1-RU3
      T=(RUS1+IUS1)*E
      IUS1=(IUS1-RUS1)*E
      RUS1=T
      T=(RUU1+IUU1)*E
      IUU1=(IUU1-RUU1)*E
      RUU1=T
      X0(K)=RSS0+RSS1
      Y0(K)=ISS0+ISS1
      IF (ZERO) GO TO 300
      R1=RUU0+RUU1
      I1=IUU0+IUU1
      R2=RSU0+ISU1
      I2=ISU0-RSU1
      R3=RUS0+IUS1
      I3=IUS0-RUS1
      R4=RSS0-RSS1
      I4=ISS0-ISS1
      R5=RUU0-RUU1
      I5=IUU0-IUU1
      R6=RSU0-ISU1
      I6=ISU0+RSU1
      R7=RUS0-IUS1
      I7=IUS0+RUS1
      X4(K)=R1*C1+I1*S1
      Y4(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      X6(K)=R3*C3+I3*S3
      Y6(K)=I3*C3-R3*S3
      X1(K)=R4*C4+I4*S4
      Y1(K)=I4*C4-R4*S4
      X5(K)=R5*C5+I5*S5
      Y5(K)=I5*C5-R5*S5
      X3(K)=R6*C6+I6*S6
      Y3(K)=I6*C6-R6*S6
      X7(K)=R7*C7+I7*S7
      Y7(K)=I7*C7-R7*S7
      GO TO 400
  300 CONTINUE
      X4(K)=RUU0+RUU1
      Y4(K)=IUU0+IUU1
      X2(K)=RSU0+ISU1
      Y2(K)=ISU0-RSU1
      X6(K)=RUS0+IUS1
      Y6(K)=IUS0-RUS1
      X1(K)=RSS0-RSS1
      Y1(K)=ISS0-ISS1
      X5(K)=RUU0-RUU1
      Y5(K)=IUU0-IUU1
      X3(K)=RSU0-ISU1
      Y3(K)=ISU0+RSU1
      X7(K)=RUS0-IUS1
      Y7(K)=IUS0+RUS1
  400 CONTINUE
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT047
C
      SUBROUTINE RP CFTK (N, M, P, R, X, Y, DIM)
C     RADIX PRIME MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, P, R, DIM(5)
c      REAL X(R,P), Y(R,P)
      real x(r,p),y(r,p)
C
      LOGICAL FOLD,ZERO
      REAL ANGLE,IS,IU,RS,RU,T,TWOPI,XT,YT
      REAL FU, FP, FJM1, FMP
      INTEGER J,JJ,K0,K,M OVER 2,MP,PM,PP,U,V
      INTEGER K1, K2, KK, L, L1, MMP, NT, SIZE, SEP
      INTEGER NS
C
      REAL AA (9,9), BB (9,9)
      REAL A (18), B (18), C (18), S (18)
      REAL IA (9), IB (9), RA (9), RB (9)
      data two pi/6.283185/
c
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M OVER 2=M/2+1
      MP=M*P
      FMP = FLOAT(MP)
      MMP = SEP*MP
      PP=P/2
      PM=P-1
      FP = FLOAT(P)
      FU = 0.0
      DO 100 U=1,PP
      FU = FU + 1.0
      ANGLE = TWO PI*FU/FP
      JJ=P-U
      A(U)=COS(ANGLE)
      B(U)=SIN(ANGLE)
      A(JJ)=A(U)
      B(JJ)=-B(U)
  100 CONTINUE
      DO 300 U=1,PP
      DO 200 V=1,PP
      JJ=U*V-U*V/P*P
      AA(V,U)=A(JJ)
      BB(V,U)=B(JJ)
  200 CONTINUE
  300 CONTINUE
C
      FJM1 = -1.0
      DO 1500 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FMP
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 700
      C(1)=COS(ANGLE)
      S(1)=SIN(ANGLE)
      DO 400 U=2,PM
      C(U)=C(U-1)*C(1)-S(U-1)*S(1)
      S(U)=S(U-1)*C(1)+C(U-1)*S(1)
  400 CONTINUE
      GO TO 700
  500 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      DO 600 U=1,PM
      T=C(U)*A(U)+S(U)*B(U)
      S(U)=-S(U)*A(U)+C(U)*B(U)
      C(U)=T
  600 CONTINUE
  700 CONTINUE
C
      DO 1400 KK = K0, NS, MMP
      DO 1340 L = KK, NT, L1
      K1 = L + SIZE
      DO 1320 K = L, K1, K2
      XT=X(K,1)
      YT=Y(K,1)
      RS=X(K,2)+X(K,P)
      IS=Y(K,2)+Y(K,P)
      RU=X(K,2)-X(K,P)
      IU=Y(K,2)-Y(K,P)
      DO 800 U=1,PP
      RA(U)=XT+RS*AA(U,1)
      IA(U)=YT+IS*AA(U,1)
      RB(U)=RU*BB(U,1)
      IB(U)=IU*BB(U,1)
  800 CONTINUE
      XT=XT+RS
      YT=YT+IS
      DO 1000 U=2,PP
      JJ=P-U
      RS=X(K,U+1)+X(K,JJ+1)
      IS=Y(K,U+1)+Y(K,JJ+1)
      RU=X(K,U+1)-X(K,JJ+1)
      IU=Y(K,U+1)-Y(K,JJ+1)
      XT=XT+RS
      YT=YT+IS
      DO 900 V=1,PP
      RA(V)=RA(V)+RS*AA(V,U)
      IA(V)=IA(V)+IS*AA(V,U)
      RB(V)=RB(V)+RU*BB(V,U)
      IB(V)=IB(V)+IU*BB(V,U)
  900 CONTINUE
 1000 CONTINUE
      X(K,1)=XT
      Y(K,1)=YT
      DO 1300 U=1,PP
      JJ=P-U
      IF (ZERO) GO TO 1100
      XT=RA(U)+IB(U)
      YT=IA(U)-RB(U)
      X(K,U+1)=XT*C(U)+YT*S(U)
      Y(K,U+1)=YT*C(U)-XT*S(U)
      XT=RA(U)-IB(U)
      YT=IA(U)+RB(U)
      X(K,JJ+1)=XT*C(JJ)+YT*S(JJ)
      Y(K,JJ+1)=YT*C(JJ)-XT*S(JJ)
      GO TO 1200
 1100 CONTINUE
      X(K,U+1)=RA(U)+IB(U)
      Y(K,U+1)=IA(U)-RB(U)
      X(K,JJ+1)=RA(U)-IB(U)
      Y(K,JJ+1)=IA(U)+RB(U)
 1200 CONTINUE
 1300 CONTINUE
 1320 CONTINUE
 1340 CONTINUE
 1400 CONTINUE
      IF (FOLD) GO TO 500
 1500 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT034
C
      SUBROUTINE REAL FT (EVEN, ODD, N, DIM,nsize)
      INTEGER N
      INTEGER DIM(5)
      REAL EVEN(nsize), ODD(nsize)
C
C     REAL FOURIER TRANSFORM
C
C     GIVEN A REAL SEQUENCE OF LENGTH 2N THIS SUBROUTINE CALCULATES THE
C     UNIQUE PART OF THE FOURIER TRANSFORM.  THE FOURIER TRANSFORM HAS
C     N + 1 UNIQUE REAL PARTS AND N - 1 UNIQUE IMAGINARY PARTS.  SINCE
C     THE REAL PART AT X(N) IS FREQUENTLY OF INTEREST, THIS SUBROUTINE
C     STORES IT AT X(N) RATHER THAN IN Y(0).  THEREFORE X AND Y MUST BE
C     OF LENGTH N + 1 INSTEAD OF N.  NOTE THAT THIS STORAGE ARRANGEMENT
C     IS DIFFERENT FROM THAT EMPLOYED BY THE HERMITIAN FOURIER TRANSFORM
C     SUBROUTINE.
C
C     FOR CONVENIENCE THE DATA IS PRESENTED IN TWO PARTS, THE FIRST
C     CONTAINING THE EVEN NUMBERED REAL TERMS AND THE SECOND CONTAINING
C     THE ODD NUMBERED TERMS (NUMBERING STARTING AT 0).  ON RETURN THE
C     REAL PART OF THE TRANSFORM REPLACES THE EVEN TERMS AND THE
C     IMAGINARY PART OF THE TRANSFORM REPLACES THE ODD TERMS.
C
      REAL A, B, C, D, E, F, ANGLE, CO, SI, TWO PI, TWO N
      INTEGER NT, D2, D3, D4, D5
      INTEGER I, J, K, L, N OVER 2, I0, I1, I2
C
      TWO PI = 6.283185
      TWO N = FLOAT(2*N)
C
      CALL CMPL FT (EVEN, ODD, N, DIM,nsize)
C
      NT = DIM(1)
      D2 = DIM(2)
      D3 = DIM(3)
      D4 = DIM(4) - 1
      D5 = DIM(5)
      N OVER 2 = N/2 + 1
C
      IF (N OVER 2 .LT. 2) GO TO 400
      DO 300 I = 2, N OVER 2
      ANGLE = TWO PI*FLOAT(I-1)/TWO N
      CO = COS(ANGLE)
      SI = SIN(ANGLE)
      I0 = (I - 1)*D2 + 1
      J = (N + 2 - 2*I)*D2
      DO 200 I1 = I0, NT, D3
      I2 = I1 + D4
      DO 100 K = I1, I2, D5
      L = K + J
      A = (EVEN(L) + EVEN(K))/2.0
      C = (EVEN(L) - EVEN(K))/2.0
      B = (ODD(L) + ODD(K))/2.0
      D=(ODD(L)-ODD(K))/2.0
      E = C*SI + B*CO
      F = C*CO - B*SI
      EVEN(K) = A + E
      EVEN(L) = A - E
      ODD(K) = F - D
      ODD(L) = F + D
  100 CONTINUE
  200 CONTINUE
  300 CONTINUE
C
  400 CONTINUE
      IF (N .LT. 1) GO TO 600
      J = N*D2
      DO 500 I1 = 1, NT, D3
      I2 = I1 + D4
      DO 500 K = I1, I2, D5
      L = K + J
      EVEN(L) = EVEN(K) - ODD(K)
      ODD(L) = 0.0
      EVEN(K) = EVEN(K) + ODD(K)
      ODD(K) = 0.0
  500 CONTINUE
C
  600 CONTINUE
      RETURN
C
      END
C--------------------------------------------------------------------
c********************************************************************
c********************************************************************
c--------------------------------------------------------------------
c                                                          29.03.85
C         M_FT1                                             V.Yu.Lunin
c
c
c         The subroutine performs the Fourier transform
c
C
C                                                 H*R   K*S   L*T
C         RO(R,S,T)=SUMMA   F(H,K,L)*EXP(-2*PI*I*(--- + --- + ---))
C                   H=0,NX-1                       NX    NY    NZ
C                   K=0,NY-1
C                   L=0,NZ-1
C
C         for  MINX<=R<=MAXX,MINY<=S<=MAXY,MINZ<=T<=MAXZ
C         suppousing RO(.,.,.) be a real-value function.
C
C
c         INPUT DATA
c         X - data to be transformed;
c             this array is considered as three-dimensional COMPLEX
c             array with dimensions (maxl+1) Nx Ny;
c             elements X(l+1,h+1,k+1) contain values of structure
c             factors (Fourier coefficients) F(h,k,l)  for
C                   -MAXH<=H<=MAXH,-MAXK<=K<=MAXK,0<=L<=MAXL
C                   (it is assumed that F(-H,K,L)=F(NX-H,K,L) ,
C                                  F(H,-K,L)=F(H,NY-K ,L) )
c             and zero values for other indexes.
c          Nx,Ny,Nz - numbers of divisions along unit cell axes;
c          maxh,maxk,maxl - restrict the indexes of nonzero structure
c             factors,
c          minx,maxx,miny,maxy,minz,maxz - restrict the part of the
c             unit cell there transform will be calculated;
c
c          OUTPUT DATA
c          X - Fourier synthesis Ro;
c              this array is considered as three-dimensional REAL array
c              with dimensions Nz  Nx  Ny;
c              elements X(t+1,r+1,s+1) contain values Ro(r,s,t);
c              the only defined Ro-values are ones with
c              minx<=r<=maxx, miny<=s<=maxy, minz<=t<=maxz;
c
c          ATTENTION
c            - the total length X-array (as real one) must be
c              Nx*Ny*Nz at least;
c            - the indexes order in input data  l h k
c                                in output data z x y;
C
C            -    NZ - must be even;
C                 NX >= 2*MAXH+1
C                 NY>=2*MAXK+1
C                 NZ>=2*MAXL+2
C                 0<=MINX<=MAXX<=NX-1
C                 0<=MINY<=MAXY<=NY-1
C                 0<=MINZ<=MAXZ<=NZ-1
C            - the Hermitian  symmetry
C                                         *                            *
C                      F(H,K,0)=F(-H,-K,0)   ,F(H,K,NZ/2)=F(-H,-K,NZ/2)
c               must be present in input data.
C
C
c          SUBROUTINE USED
c             one-dimensional Fast Fourier Transform package of
c             L.F.Ten Eyck;
c             FT1A
C
c
      SUBROUTINE M_FT1(X,NX,NY,NZ,MAXH,MAXL,MINX,MAXX,MINY,MAXY,
     *               nsize)
C
      DIMENSION X(nsize),K(5)
C
C
C
      K(1)=2*(MAXL+1)*NX*NY
      K(2)=2*(MAXL+1)*NX
      K(3)=2*(MAXL+1)*NX*NY
      K(4)=2*(MAXL+1)*(MAXH+1)
      K(5)=2
      CALL CMPLFT(X(1),X(2),NY,K,nsize)
C
      K(4)=2*(MAXL+1)*MAXH
      JA=(NX-MAXH)*2*(MAXL+1)+1
      CALL CMPLFT(X(JA),X(JA+1),NY,K,nsize)
C
C
C
      JA=MINY*2*(MAXL+1)*NX+1
      K(1)=2*(MAXL+1)*NX*(MAXY-MINY+1)
      K(2)=2*(MAXL+1)
      K(3)=2*(MAXL+1)*NX
      K(4)=2*(MAXL+1)
      K(5)=2
      CALL CMPLFT(X(JA),X(JA+1),NX,K,nsize)
C
C
C
      N3=2*(MAXL+1)
      IF(N3.EQ.NZ) GOTO 50
      CALL FT1A(X,N3,NX,NY,X,NZ,NX,NY)
50    CONTINUE
C
C
      JA=    NZ*NX*MINY+    NZ*MINX+1
      K(1)=    NZ*NX*(MAXY-MINY+1)
      K(2)=2
      K(3)=    NZ*NX
      K(4)=    NZ*(MAXX-MINX+1)
      K(5)=NZ
C
C
C
      K1=K(1)
      K3=K(3)
      K5=K(5)
C
C
      IF(N3.EQ.NZ) GOTO 220
      DO 210 J1=JA,K1,K3
      K4=K(4)+J1-1
      DO 200 J=J1,K4,K5
      K6=J+N3
      K7=J+NZ-1
      DO 190 J2=K6,K7
      X(J2)=0.
190   CONTINUE
200   CONTINUE
210   CONTINUE
C
C
220   CONTINUE
C
C
C
      CALL HERMFT(X(JA),X(JA+1),NZ/2,K,nsize)
C
      RETURN
      END
c
c--------------------------------------------------------------------
c     The  decompressing the X-array into Y-array.
c
c     ATTENTION !
c     It is suppoused n1<=k1, n2<=k2, n3<=k3.
c
      SUBROUTINE FT1A(X,n1,n2,n3,Y,k1,k2,k3)
c
      dimension X(n1,n2,n3), Y(k1,k2,k3)
c
      do 50 i3=1,n3
        m3=n3-i3+1
        do 40 i2=1,n2
          m2=n2-i2+1
          do 30 i1=1,n1
            m1=n1-i1+1
            Y(m1,m2,m3)=X(m1,m2,m3)
30        continue
40      continue
50    continue
c
c
      return
      end
c
c********************************************************************
c*********************************************************************
c  ********                                         18 September 1997
c  * FFT1 *                                         V.Yu.Lunin
c  ********
c
      SUBROUTINE FFT1(nsym,sym,nref,ih,ik,il,f,phi,nx,ny,nz,
     *                ro,mes)
      dimension sym(12,nsym)
      dimension ih(nref),ik(nref),il(nref),f(nref),phi(nref)
      dimension ro(nx,ny,nz)
c
c         The subroutine performs the Fourier transform
C
C                                                 h*r   k*s   l*t
C         ro(r,s,t)=SUMMA   F(h,k,l)*EXP(-2*PI*I*(--- + --- + ---))
C                   h,k,l                          nx    ny    nz
C
C         for  0<=r<=nx-1, 0<=s<=ny-1, 0<=t<=nz-1
C         suppousing ro(.,.,.) be a real-value function.
c
c     INPUT DATA
c       nsym - number of symmetries operations, which will be applied
c              to input structure factors;
c       sym(.,.) - crystallographic symmetries operations for real
c              space with the order of elemets
c              g11,g21,g31,g12,g22,g32,g13,g23,g33,t1,t2,t3
c       nref - number of reflections to be used;
c       ih(.),ik(.),il(.) - there indexes;
c       f(.),phi(.) - there phases (in RADIANS)
c       nx,ny,nz - number of divisions along the unit cell sides;
c       mes - a number of the unit for abnormal messages;
c
c     OUTPUT DATA
c       ro(.,.,.) - calculated Fourier Transform
c
c     ATTENTION
c       - nx must be even;
c       - for calculations will be used all reflections prepared
c         with the use of specified symmetries and Hermitian symmetry,
c         provided that
c            !h!<=(nx-2)/2, !k!<=(ny-1)/2, !l!<=(nz-1)/2
c
c      NECESSARY SUBROUTINES
c        FFTKER.FOR - suite
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      twopi=6.2831852
      if((nx/2)*2.ne.nx) then
        if(mes.gt.0) write(mes,1000) nx
        STOP
      endif
      minh=0
      maxh=(nx-2)/2
      maxk=(ny-1)/2
      mink=-maxk
      maxl=(nz-1)/2
      minl=-maxl
      minx=0
      maxx=nx-1
      miny=0
      maxy=ny-1
      minz=0
      maxz=nz-1
c
c         preparing structure factors array
c
      ntotal=nx*ny*nz
      CALL ZERO(ro,ntotal)
c
      do jref=1,nref
        jh=ih(jref)
        jk=ik(jref)
        jl=il(jref)

        do jsym=1,nsym
          m11=INTR(sym(1,jsym))
          m21=INTR(sym(2,jsym))
          m31=INTR(sym(3,jsym))
          m12=INTR(sym(4,jsym))
          m22=INTR(sym(5,jsym))
          m32=INTR(sym(6,jsym))
          m13=INTR(sym(7,jsym))
          m23=INTR(sym(8,jsym))
          m33=INTR(sym(9,jsym))
          t1=-sym(10,jsym)*twopi
          t2=-sym(11,jsym)*twopi
          t3=-sym(12,jsym)*twopi
c
          kh=m11*jh+m21*jk+m31*jl
          kk=m12*jh+m22*jk+m32*jl
          kl=m13*jh+m23*jk+m33*jl
c
          if(kh.ge.minh .and. kh.le.maxh .and.
     *       kk.ge.mink .and. kk.le.maxk .and.
     *       kl.ge.minl .and. kl.le.maxl ) then
               fw=f(jref)
               pw=phi(jref)+t1*jh+t2*jk+t3*jl
               i1=2*kh+1
               if(kk.ge.0) then
                 i2=kk+1
               else
                 i2=ny+kk+1
               endif
               if(kl.ge.0) then
                 i3=kl+1
               else
                 i3=nz+kl+1
               endif
               ro(i1,i2,i3)=fw*cos(pw)
               ro(i1+1,i2,i3)=fw*sin(pw)
          endif
c
          kh=-kh
          kk=-kk
          kl=-kl
          if(kh.ge.minh .and. kh.le.maxh .and.
     *       kk.ge.mink .and. kk.le.maxk .and.
     *       kl.ge.minl .and. kl.le.maxl ) then
               fw=f(jref)
               pw=-phi(jref)-t1*jh-t2*jk-t3*jl
               i1=2*kh+1
               if(kk.ge.0) then
                 i2=kk+1
               else
                 i2=ny+kk+1
               endif
               if(kl.ge.0) then
                 i3=kl+1
               else
                 i3=nz+kl+1
               endif
               ro(i1,i2,i3)=fw*cos(pw)
               ro(i1+1,i2,i3)=fw*sin(pw)
          endif
        enddo
      enddo
c
c        the changing oif variables is connected with some crazy
c        things in organizing of FT1 subroutine
c
      CALL M_FT1(ro,ny,nz,nx,maxk,maxh,miny,maxy,minz,maxz,
     *         ntotal)
c
      RETURN
c
1000  format(1x,'** FFT1 **  the first dimension must be even, not',
     *       i5)
c
      END
c
c -------------------------------------------------------------------
c
      SUBROUTINE ZERO(x,n)
      dimension x(n)
      do j=1,n
        x(j)=0.
      enddo
      RETURN
      END
c
c--------------------------------------------------------------------
c
      FUNCTION INTR(x)
c        returnes the nearest to x integer value
c
      if(x.ge.0.) then
        j=x+0.5
      else
        j=x-0.5
      endif
      intr=j
      RETURN
      END
c
c****************************************************************
